 !----------------------------------------------------------------------------
 !
 !                    f90gl version 1.2.12, September 2006
 !
 !     William F. Mitchell
 !     Mathematical and Computational Sciences Division
 !     National Institute of Standards and Technology
 !     william.mitchell@nist.gov
 !     http://math.nist.gov/f90gl
 !
 ! f90gl is public domain software.  It was produced as part of work done by
 ! the U.S. Government, and is not subject to copyright in the United States.
 !
 !----------------------------------------------------------------------------
 
 
 
 module opengl_glinterfaces
 
 ! interface blocks for the C wrappers.
 
 
 
 
 
 
 
 use opengl_kinds
 
 
 private
 
 !--------------------------
 ! C wrapper procedure names
 !--------------------------
 
 ! OpenGL 1.0
 
 public :: &
    fglaccum, &
    fglalphafunc, &
    fglbegin, &
    fglbitmap, &
    f9bglbitmap, &
    f9cglbitmap, &
    fglblendfunc, &
    fglcalllist, &
    f9y0glcalllists, &
    f9y1glcalllists, &
    f9y4glcalllists, &
    f9y5glcalllists, &
    f9y6glcalllists, &
    fglclear, &
    fglclearaccum, &
    fglclearcolor, &
    fglcleardepth, &
    fglclearindex, &
    fglclearstencil, &
    fglclipplane, &
    fglcolor3b, &
    f9bglcolor3b, &
    f9cglcolor3b, &
    fglcolor3bv, &
    f9bglcolor3bv, &
    f9cglcolor3bv, &
    fglcolor3d, &
    fglcolor3dv, &
    fglcolor3f, &
    fglcolor3fv, &
    fglcolor3i, &
    fglcolor3iv, &
    fglcolor3s, &
    f9aglcolor3s, &
    fglcolor3sv, &
    f9aglcolor3sv
 public :: &
    fglcolor3ub, &
    f9bglcolor3ub, &
    f9cglcolor3ub, &
    fglcolor3ubv, &
    f9bglcolor3ubv, &
    f9cglcolor3ubv, &
    fglcolor3ui, &
    fglcolor3uiv, &
    fglcolor3us, &
    f9aglcolor3us, &
    fglcolor3usv, &
    f9aglcolor3usv, &
    fglcolor4b, &
    f9bglcolor4b, &
    f9cglcolor4b, &
    fglcolor4bv, &
    f9bglcolor4bv, &
    f9cglcolor4bv, &
    fglcolor4d, &
    fglcolor4dv, &
    fglcolor4f, &
    fglcolor4fv, &
    fglcolor4i, &
    fglcolor4iv, &
    fglcolor4s, &
    f9aglcolor4s, &
    fglcolor4sv, &
    f9aglcolor4sv, &
    fglcolor4ub, &
    f9bglcolor4ub, &
    f9cglcolor4ub, &
    fglcolor4ubv, &
    f9bglcolor4ubv, &
    f9cglcolor4ubv, &
    fglcolor4ui, &
    fglcolor4uiv
 public :: &
    fglcolor4us, &
    f9aglcolor4us, &
    fglcolor4usv, &
    f9aglcolor4usv, &
    fglcolormask, &
    f9eglcolormask, &
    fglcolormaterial, &
    fglcopypixels, &
    fglcullface, &
    fgldeletelists, &
    fgldepthfunc, &
    fgldepthmask, &
    f9egldepthmask, &
    fgldepthrange, &
    fgldisable, &
    fgldrawbuffer, &
    f9y0gldrawpixels, &
    f9y1gldrawpixels, &
    f9y4gldrawpixels, &
    f9y5gldrawpixels, &
    f9y6gldrawpixels, &
    fgledgeflag, &
    f9egledgeflag, &
    fgledgeflagv, &
    f9egledgeflagv, &
    fglenable, &
    fglend, &
    fglendlist, &
    fglevalcoord1d, &
    fglevalcoord1dv, &
    fglevalcoord1f, &
    fglevalcoord1fv, &
    fglevalcoord2d, &
    fglevalcoord2dv
 public :: &
    fglevalcoord2f, &
    fglevalcoord2fv, &
    fglevalmesh1, &
    fglevalmesh2, &
    fglevalpoint1, &
    fglevalpoint2, &
    fglfeedbackbuffer, &
    fglfinish, &
    fglflush, &
    fglfogf, &
    fglfogfv, &
    fglfogi, &
    fglfogiv, &
    fglfrontface, &
    fglfrustum, &
    fglgenlists, &
    fglgetbooleanv, &
    f9eglgetbooleanv, &
    fglgetclipplane, &
    fglgetdoublev, &
    fglgeterror, &
    fglgetfloatv, &
    fglgetintegerv, &
    fglgetlightfv, &
    fglgetlightiv, &
    fglgetmapdv, &
    fglgetmapfv, &
    fglgetmapiv, &
    fglgetmaterialfv, &
    fglgetmaterialiv, &
    fglgetpixelmapfv, &
    fglgetpixelmapuiv, &
    fglgetpixelmapusv, &
    f9aglgetpixelmapusv
 public :: &
    fglgetpolygonstipple, &
    f9bglgetpolygonstipple, &
    f9cglgetpolygonstipple, &
    f9yglgetstringlen, &
    f9yglgetstring, &
    f9yglgetstring1, &
    f9yglgetstringfree, &
    fglgettexenvfv, &
    fglgettexenviv, &
    fglgettexgendv, &
    fglgettexgenfv, &
    fglgettexgeniv, &
    f9y0glgetteximage, &
    f9y1glgetteximage, &
    f9y4glgetteximage, &
    f9y5glgetteximage, &
    f9y6glgetteximage, &
    fglgettexlevelparameterfv, &
    fglgettexlevelparameteriv, &
    fglgettexparameterfv, &
    fglgettexparameteriv, &
    fglhint, &
    fglindexmask, &
    fglindexd, &
    fglindexdv, &
    fglindexf, &
    fglindexfv, &
    fglindexi, &
    fglindexiv, &
    fglindexs, &
    f9aglindexs, &
    fglindexsv, &
    f9aglindexsv, &
    fglinitnames, &
    fglisenabled, &
    f9eglisenabled
 public :: &
    fglislist, &
    f9eglislist, &
    fgllightmodelf, &
    fgllightmodelfv, &
    fgllightmodeli, &
    fgllightmodeliv, &
    fgllightf, &
    fgllightfv, &
    fgllighti, &
    fgllightiv, &
    fgllinestipple, &
    f9agllinestipple, &
    fgllinewidth, &
    fgllistbase, &
    fglloadidentity, &
    fglloadmatrixd, &
    fglloadmatrixf, &
    fglloadname, &
    fgllogicop, &
    fglmap1d, &
    fglmap1f, &
    fglmap2d, &
    fglmap2f, &
    fglmapgrid1d, &
    fglmapgrid1f, &
    fglmapgrid2d, &
    fglmapgrid2f, &
    fglmaterialf, &
    fglmaterialfv, &
    fglmateriali, &
    fglmaterialiv, &
    fglmatrixmode, &
    fglmultmatrixd, &
    fglmultmatrixf
 public :: &
    fglnewlist, &
    fglnormal3b, &
    f9bglnormal3b, &
    f9cglnormal3b, &
    fglnormal3bv, &
    f9bglnormal3bv, &
    f9cglnormal3bv, &
    fglnormal3d, &
    fglnormal3dv, &
    fglnormal3f, &
    fglnormal3fv, &
    fglnormal3i, &
    fglnormal3iv, &
    fglnormal3s, &
    f9aglnormal3s, &
    fglnormal3sv, &
    f9aglnormal3sv, &
    fglortho, &
    fglpassthrough, &
    fglpixelmapfv, &
    fglpixelmapuiv, &
    fglpixelmapusv, &
    f9aglpixelmapusv, &
    fglpixelstoref, &
    fglpixelstorei, &
    fglpixeltransferf, &
    fglpixeltransferi, &
    fglpixelzoom, &
    fglpointsize, &
    fglpolygonmode, &
    fglpolygonstipple, &
    f9bglpolygonstipple, &
    f9cglpolygonstipple, &
    fglpopattrib
 public :: &
    fglpopmatrix, &
    fglpopname, &
    fglpushattrib, &
    fglpushmatrix, &
    fglpushname, &
    fglrasterpos2d, &
    fglrasterpos2dv, &
    fglrasterpos2f, &
    fglrasterpos2fv, &
    fglrasterpos2i, &
    fglrasterpos2iv, &
    fglrasterpos2s, &
    f9aglrasterpos2s, &
    fglrasterpos2sv, &
    f9aglrasterpos2sv, &
    fglrasterpos3d, &
    fglrasterpos3dv, &
    fglrasterpos3f, &
    fglrasterpos3fv, &
    fglrasterpos3i, &
    fglrasterpos3iv, &
    fglrasterpos3s, &
    f9aglrasterpos3s, &
    fglrasterpos3sv, &
    f9aglrasterpos3sv, &
    fglrasterpos4d, &
    fglrasterpos4dv, &
    fglrasterpos4f, &
    fglrasterpos4fv, &
    fglrasterpos4i, &
    fglrasterpos4iv, &
    fglrasterpos4s, &
    f9aglrasterpos4s, &
    fglrasterpos4sv, &
    f9aglrasterpos4sv
 public :: &
    fglreadbuffer, &
    f9y0glreadpixels, &
    f9y1glreadpixels, &
    f9y4glreadpixels, &
    f9y5glreadpixels, &
    f9y6glreadpixels, &
    fglrectd, &
    fglrectdv, &
    fglrectf, &
    fglrectfv, &
    fglrecti, &
    fglrectiv, &
    fglrects, &
    f9aglrects, &
    fglrectsv, &
    f9aglrectsv, &
    fglrendermode, &
    fglrotated, &
    fglrotatef, &
    fglscaled, &
    fglscalef, &
    fglscissor, &
    fglselectbuffer, &
    fglshademodel, &
    fglstencilfunc, &
    fglstencilmask, &
    fglstencilop, &
    fgltexcoord1d, &
    fgltexcoord1dv, &
    fgltexcoord1f
 public :: &
    fgltexcoord1fv, &
    fgltexcoord1i, &
    fgltexcoord1iv, &
    fgltexcoord1s, &
    f9agltexcoord1s, &
    fgltexcoord1sv, &
    f9agltexcoord1sv, &
    fgltexcoord2d, &
    fgltexcoord2dv, &
    fgltexcoord2f, &
    fgltexcoord2fv, &
    fgltexcoord2i, &
    fgltexcoord2iv, &
    fgltexcoord2s, &
    f9agltexcoord2s, &
    fgltexcoord2sv, &
    f9agltexcoord2sv, &
    fgltexcoord3d, &
    fgltexcoord3dv, &
    fgltexcoord3f, &
    fgltexcoord3fv, &
    fgltexcoord3i, &
    fgltexcoord3iv, &
    fgltexcoord3s, &
    f9agltexcoord3s, &
    fgltexcoord3sv, &
    f9agltexcoord3sv, &
    fgltexcoord4d, &
    fgltexcoord4dv, &
    fgltexcoord4f, &
    fgltexcoord4fv, &
    fgltexcoord4i, &
    fgltexcoord4iv, &
    fgltexcoord4s, &
    f9agltexcoord4s, &
    fgltexcoord4sv
 public :: &
    f9agltexcoord4sv, &
    fgltexenvf, &
    fgltexenvfv, &
    fgltexenvi, &
    fgltexenviv, &
    fgltexgend, &
    fgltexgendv, &
    fgltexgenf, &
    fgltexgenfv, &
    fgltexgeni, &
    fgltexgeniv, &
    f9y0glteximage1d, &
    f9y1glteximage1d, &
    f9y4glteximage1d, &
    f9y5glteximage1d, &
    f9y6glteximage1d, &
    f9y0glteximage2d, &
    f9y1glteximage2d, &
    f9y4glteximage2d, &
    f9y5glteximage2d, &
    f9y6glteximage2d, &
    fgltexparameterf, &
    fgltexparameterfv, &
    fgltexparameteri, &
    fgltexparameteriv, &
    fgltranslated, &
    fgltranslatef, &
    fglvertex2d, &
    fglvertex2dv, &
    fglvertex2f, &
    fglvertex2fv, &
    fglvertex2i, &
    fglvertex2iv, &
    fglvertex2s, &
    f9aglvertex2s, &
    fglvertex2sv, &
    f9aglvertex2sv
 public :: &
    fglvertex3d, &
    fglvertex3dv, &
    fglvertex3f, &
    fglvertex3fv, &
    fglvertex3i, &
    fglvertex3iv, &
    fglvertex3s, &
    f9aglvertex3s, &
    fglvertex3sv, &
    f9aglvertex3sv, &
    fglvertex4d, &
    fglvertex4dv, &
    fglvertex4f, &
    fglvertex4fv, &
    fglvertex4i, &
    fglvertex4iv, &
    fglvertex4s, &
    f9aglvertex4s, &
    fglvertex4sv, &
    f9aglvertex4sv, &
    fglviewport
 
 ! OpenGL 1.1
 
 public :: &
    fglaretexturesresident, &
    f9eglaretexturesresident, &
    fglarrayelement, &
    fglbindtexture, &
    f9y0glcolorpointer, &
    f9y1glcolorpointer, &
    f9y4glcolorpointer, &
    f9y5glcolorpointer, &
    f9y6glcolorpointer, &
    f9y7glcolorpointer, &
    fglcopyteximage1d, &
    fglcopyteximage2d, &
    fglcopytexsubimage1d, &
    fglcopytexsubimage2d, &
    fgldeletetextures, &
    fgldisableclientstate, &
    fgldrawarrays, &
    f9y0gldrawelements, &
    f9y4gldrawelements, &
    f9y5gldrawelements, &
    f9y6gldrawelements, &
    fgledgeflagpointer, &
    f9egledgeflagpointer, &
    fglenableclientstate, &
    fglgentextures, &
    fglgetpointerv, &
    f9y0glindexpointer, &
    f9y1glindexpointer, &
    f9y4glindexpointer, &
    f9y6glindexpointer, &
    f9y7glindexpointer, &
    fglindexub, &
    f9bglindexub, &
    f9cglindexub, &
    fglindexubv, &
    f9bglindexubv
 public :: &
    f9cglindexubv, &
    f9y0glinterleavedarrays, &
    f9y4glinterleavedarrays, &
    f9y1glinterleavedarrays, &
    f9y5glinterleavedarrays, &
    f9y6glinterleavedarrays, &
    fglistexture, &
    f9eglistexture, &
    f9y0glnormalpointer, &
    f9y1glnormalpointer, &
    f9y4glnormalpointer, &
    f9y5glnormalpointer, &
    f9y6glnormalpointer, &
    f9y7glnormalpointer, &
    fglpolygonoffset, &
    fglpopclientattrib, &
    fglprioritizetextures, &
    fglpushclientattrib, &
    f9y0gltexcoordpointer, &
    f9y1gltexcoordpointer, &
    f9y4gltexcoordpointer, &
    f9y6gltexcoordpointer, &
    f9y7gltexcoordpointer, &
    f9y0gltexsubimage1d, &
    f9y1gltexsubimage1d, &
    f9y4gltexsubimage1d, &
    f9y5gltexsubimage1d, &
    f9y6gltexsubimage1d, &
    f9y0gltexsubimage2d, &
    f9y1gltexsubimage2d, &
    f9y4gltexsubimage2d
 public :: &
    f9y5gltexsubimage2d, &
    f9y6gltexsubimage2d, &
    f9y0glvertexpointer, &
    f9y1glvertexpointer, &
    f9y4glvertexpointer, &
    f9y6glvertexpointer, &
    f9y7glvertexpointer
 
 ! OpenGL 1.2
 
 public :: &
    f9y0gldrawrangeelements, &
    f9y4gldrawrangeelements, &
    f9y5gldrawrangeelements, &
    f9y6gldrawrangeelements, &
    f9y0glteximage3d, &
    f9y1glteximage3d, &
    f9y4glteximage3d, &
    f9y5glteximage3d, &
    f9y6glteximage3d, &
    f9y0gltexsubimage3d, &
    f9y1gltexsubimage3d, &
    f9y4gltexsubimage3d, &
    f9y5gltexsubimage3d, &
    f9y6gltexsubimage3d, &
    fglcopytexsubimage3d
 
 ! EXT_blend_color
 
 public :: &
    fglblendcolorext
 
 ! EXT_blend_minmax
 
 public :: &
    fglblendequationext
 
 ! EXT_color_table
 
 
 ! EXT_point_parameters
 
 public :: &
    fglpointparameterfext, &
    fglpointparameterfvext
 
 ! EXT_polygon_offset
 
 
 ! EXT_subtexture
 
 
 ! EXT_texture3D
 
 public :: &
    f9y0glteximage3dext, &
    f9y1glteximage3dext, &
    f9y4glteximage3dext, &
    f9y5glteximage3dext, &
    f9y6glteximage3dext, &
    f9y0gltexsubimage3dext, &
    f9y1gltexsubimage3dext, &
    f9y4gltexsubimage3dext, &
    f9y5gltexsubimage3dext, &
    f9y6gltexsubimage3dext, &
    fglcopytexsubimage3dext
 
 ! EXT_texture_object
 
 public :: &
    fglgentexturesext, &
    fgldeletetexturesext, &
    fglbindtextureext, &
    fglprioritizetexturesext, &
    fglaretexturesresidentext, &
    f9eglaretexturesresidentext, &
    fglistextureext, &
    f9eglistextureext
 
 ! EXT_vertex_array
 
 public :: &
    f9y0glvertexpointerext, &
    f9y1glvertexpointerext, &
    f9y4glvertexpointerext, &
    f9y6glvertexpointerext, &
    f9y7glvertexpointerext, &
    f9y0glnormalpointerext, &
    f9y1glnormalpointerext, &
    f9y4glnormalpointerext, &
    f9y5glnormalpointerext, &
    f9y6glnormalpointerext, &
    f9y7glnormalpointerext, &
    f9y0glcolorpointerext, &
    f9y1glcolorpointerext, &
    f9y4glcolorpointerext, &
    f9y5glcolorpointerext, &
    f9y6glcolorpointerext, &
    f9y7glcolorpointerext, &
    f9y0glindexpointerext, &
    f9y1glindexpointerext, &
    f9y4glindexpointerext, &
    f9y6glindexpointerext, &
    f9y7glindexpointerext, &
    f9y0gltexcoordpointerext, &
    f9y1gltexcoordpointerext, &
    f9y4gltexcoordpointerext, &
    f9y6gltexcoordpointerext, &
    f9y7gltexcoordpointerext, &
    fgledgeflagpointerext, &
    f9egledgeflagpointerext, &
    fglgetpointervext, &
    fglarrayelementext, &
    fgldrawarraysext
 
 ! SGIS_multisample
 
 
 ! MESA_resize_buffers
 
 
 ! MESA_window_pos
 
 
 !-----------------
 ! Interface blocks
 !-----------------
 
 ! OpenGL 1.0
 
 interface
 subroutine fglaccum(op,value)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: op
 real(kind=glfloat) ,intent(in) :: value
 end subroutine fglaccum
 end interface
 
 interface
 subroutine fglalphafunc(func,ref)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: func
 real(kind=glclampf) ,intent(in) :: ref
 end subroutine fglalphafunc
 end interface
 
 interface
 subroutine fglbegin(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglbegin
 end interface
 
 interface
 subroutine fglbitmap(width,height,xorig,yorig,xmove,ymove, &
    bitmap)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 real(kind=glfloat) ,intent(in) :: xorig, yorig, xmove, ymove
 integer(kind=glubyte), dimension(*) ,intent(in) :: bitmap
 end subroutine fglbitmap
 end interface
 
 interface
 subroutine f9bglbitmap(width,height,xorig,yorig,xmove,ymove, &
    bitmap,xsize)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 real(kind=glfloat) ,intent(in) :: xorig, yorig, xmove, ymove
 integer(kind=glubyte), dimension(*) ,intent(in) :: bitmap
 integer(kind=glint) ,intent(in) :: xsize
 end subroutine f9bglbitmap
 end interface
 
 interface
 subroutine f9cglbitmap(width,height,xorig,yorig,xmove,ymove, &
    bitmap,xsize)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 real(kind=glfloat) ,intent(in) :: xorig, yorig, xmove, ymove
 integer(kind=glubyte), dimension(*) ,intent(in) :: bitmap
 integer(kind=glint) ,intent(in) :: xsize
 end subroutine f9cglbitmap
 end interface
 
 interface
 subroutine fglblendfunc(sfactor,dfactor)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: sfactor, dfactor
 end subroutine fglblendfunc
 end interface
 
 interface
 subroutine fglcalllist(list)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: list
 end subroutine fglcalllist
 end interface
 
 interface
 subroutine f9y0glcalllists(n,itype,lists)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=glenum) ,intent(in) :: itype
 integer(kind=glint), dimension(*) ,intent(in) :: lists
 end subroutine f9y0glcalllists
 end interface
 
 interface
 subroutine f9y1glcalllists(n,itype,lists)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=glenum) ,intent(in) :: itype
 real(kind=glfloat), dimension(*) ,intent(in) :: lists
 end subroutine f9y1glcalllists
 end interface
 
 interface
 subroutine f9y4glcalllists(n,itype,lists,length)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=glenum) ,intent(in) :: itype
 integer(kind=gluint), dimension(*) ,intent(in) :: lists
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glcalllists
 end interface
 
 interface
 subroutine f9y5glcalllists(n,itype,lists)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=glenum) ,intent(in) :: itype
 integer(kind=glbyte), dimension(*) ,intent(in) :: lists
 end subroutine f9y5glcalllists
 end interface
 
 interface
 subroutine f9y6glcalllists(n,itype,lists)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=glenum) ,intent(in) :: itype
 integer(kind=glshort), dimension(*) ,intent(in) :: lists
 end subroutine f9y6glcalllists
 end interface
 
 interface
 subroutine fglclear(mask)
 use opengl_kinds
 implicit none
 integer(kind=glbitfield) ,intent(in) :: mask
 end subroutine fglclear
 end interface
 
 interface
 subroutine fglclearaccum(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: red, green, blue, alpha
 end subroutine fglclearaccum
 end interface
 
 interface
 subroutine fglclearcolor(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 real(kind=glclampf) ,intent(in) :: red, green, blue, alpha
 end subroutine fglclearcolor
 end interface
 
 interface
 subroutine fglcleardepth(depth)
 use opengl_kinds
 implicit none
 real(kind=glclampd) ,intent(in) :: depth
 end subroutine fglcleardepth
 end interface
 
 interface
 subroutine fglclearindex(c)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: c
 end subroutine fglclearindex
 end interface
 
 interface
 subroutine fglclearstencil(s)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: s
 end subroutine fglclearstencil
 end interface
 
 interface
 subroutine fglclipplane(plane,equation)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: plane
 real(kind=gldouble), dimension(*) ,intent(in) :: equation
 end subroutine fglclipplane
 end interface
 
 interface
 subroutine fglcolor3b(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue
 end subroutine fglcolor3b
 end interface
 
 interface
 subroutine f9bglcolor3b(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue
 end subroutine f9bglcolor3b
 end interface
 
 interface
 subroutine f9cglcolor3b(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue
 end subroutine f9cglcolor3b
 end interface
 
 interface
 subroutine fglcolor3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3bv
 end interface
 
 interface
 subroutine f9bglcolor3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9bglcolor3bv
 end interface
 
 interface
 subroutine f9cglcolor3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9cglcolor3bv
 end interface
 
 interface
 subroutine fglcolor3d(red,green,blue)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: red, green, blue
 end subroutine fglcolor3d
 end interface
 
 interface
 subroutine fglcolor3dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3dv
 end interface
 
 interface
 subroutine fglcolor3f(red,green,blue)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: red, green, blue
 end subroutine fglcolor3f
 end interface
 
 interface
 subroutine fglcolor3fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3fv
 end interface
 
 interface
 subroutine fglcolor3i(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: red, green, blue
 end subroutine fglcolor3i
 end interface
 
 interface
 subroutine fglcolor3iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3iv
 end interface
 
 interface
 subroutine fglcolor3s(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: red, green, blue
 end subroutine fglcolor3s
 end interface
 
 interface
 subroutine f9aglcolor3s(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: red, green, blue
 end subroutine f9aglcolor3s
 end interface
 
 interface
 subroutine fglcolor3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3sv
 end interface
 
 interface
 subroutine f9aglcolor3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglcolor3sv
 end interface
 
 interface
 subroutine fglcolor3ub(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue
 end subroutine fglcolor3ub
 end interface
 
 interface
 subroutine f9bglcolor3ub(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue
 end subroutine f9bglcolor3ub
 end interface
 
 interface
 subroutine f9cglcolor3ub(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue
 end subroutine f9cglcolor3ub
 end interface
 
 interface
 subroutine fglcolor3ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3ubv
 end interface
 
 interface
 subroutine f9bglcolor3ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine f9bglcolor3ubv
 end interface
 
 interface
 subroutine f9cglcolor3ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine f9cglcolor3ubv
 end interface
 
 interface
 subroutine fglcolor3ui(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: red, green, blue
 end subroutine fglcolor3ui
 end interface
 
 interface
 subroutine fglcolor3uiv(v)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3uiv
 end interface
 
 interface
 subroutine fglcolor3us(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glushort) ,intent(in) :: red, green, blue
 end subroutine fglcolor3us
 end interface
 
 interface
 subroutine f9aglcolor3us(red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glushort) ,intent(in) :: red, green, blue
 end subroutine f9aglcolor3us
 end interface
 
 interface
 subroutine fglcolor3usv(v)
 use opengl_kinds
 implicit none
 integer(kind=glushort), dimension(*) ,intent(in) :: v
 end subroutine fglcolor3usv
 end interface
 
 interface
 subroutine f9aglcolor3usv(v)
 use opengl_kinds
 implicit none
 integer(kind=glushort), dimension(*) ,intent(in) :: v
 end subroutine f9aglcolor3usv
 end interface
 
 interface
 subroutine fglcolor4b(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4b
 end interface
 
 interface
 subroutine f9bglcolor4b(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue, alpha
 end subroutine f9bglcolor4b
 end interface
 
 interface
 subroutine f9cglcolor4b(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: red, green, blue, alpha
 end subroutine f9cglcolor4b
 end interface
 
 interface
 subroutine fglcolor4bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4bv
 end interface
 
 interface
 subroutine f9bglcolor4bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9bglcolor4bv
 end interface
 
 interface
 subroutine f9cglcolor4bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9cglcolor4bv
 end interface
 
 interface
 subroutine fglcolor4d(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4d
 end interface
 
 interface
 subroutine fglcolor4dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4dv
 end interface
 
 interface
 subroutine fglcolor4f(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4f
 end interface
 
 interface
 subroutine fglcolor4fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4fv
 end interface
 
 interface
 subroutine fglcolor4i(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4i
 end interface
 
 interface
 subroutine fglcolor4iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4iv
 end interface
 
 interface
 subroutine fglcolor4s(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4s
 end interface
 
 interface
 subroutine f9aglcolor4s(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: red, green, blue, alpha
 end subroutine f9aglcolor4s
 end interface
 
 interface
 subroutine fglcolor4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4sv
 end interface
 
 interface
 subroutine f9aglcolor4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglcolor4sv
 end interface
 
 interface
 subroutine fglcolor4ub(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4ub
 end interface
 
 interface
 subroutine f9bglcolor4ub(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue, alpha
 end subroutine f9bglcolor4ub
 end interface
 
 interface
 subroutine f9cglcolor4ub(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: red, green, blue, alpha
 end subroutine f9cglcolor4ub
 end interface
 
 interface
 subroutine fglcolor4ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4ubv
 end interface
 
 interface
 subroutine f9bglcolor4ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine f9bglcolor4ubv
 end interface
 
 interface
 subroutine f9cglcolor4ubv(v)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: v
 end subroutine f9cglcolor4ubv
 end interface
 
 interface
 subroutine fglcolor4ui(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4ui
 end interface
 
 interface
 subroutine fglcolor4uiv(v)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4uiv
 end interface
 
 interface
 subroutine fglcolor4us(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glushort) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolor4us
 end interface
 
 interface
 subroutine f9aglcolor4us(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glushort) ,intent(in) :: red, green, blue, alpha
 end subroutine f9aglcolor4us
 end interface
 
 interface
 subroutine fglcolor4usv(v)
 use opengl_kinds
 implicit none
 integer(kind=glushort), dimension(*) ,intent(in) :: v
 end subroutine fglcolor4usv
 end interface
 
 interface
 subroutine f9aglcolor4usv(v)
 use opengl_kinds
 implicit none
 integer(kind=glushort), dimension(*) ,intent(in) :: v
 end subroutine f9aglcolor4usv
 end interface
 
 interface
 subroutine fglcolormask(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 logical(kind=glboolean) ,intent(in) :: red, green, blue, alpha
 end subroutine fglcolormask
 end interface
 
 interface
 subroutine f9eglcolormask(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: red, green, blue, alpha
 end subroutine f9eglcolormask
 end interface
 
 interface
 subroutine fglcolormaterial(face,mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, mode
 end subroutine fglcolormaterial
 end interface
 
 interface
 subroutine fglcopypixels(x,y,width,height,xtype)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: xtype
 end subroutine fglcopypixels
 end interface
 
 interface
 subroutine fglcullface(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglcullface
 end interface
 
 interface
 subroutine fgldeletelists(list,xrange)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: list
 integer(kind=glsizei) ,intent(in) :: xrange
 end subroutine fgldeletelists
 end interface
 
 interface
 subroutine fgldepthfunc(func)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: func
 end subroutine fgldepthfunc
 end interface
 
 interface
 subroutine fgldepthmask(flag)
 use opengl_kinds
 implicit none
 logical(kind=glboolean) ,intent(in) :: flag
 end subroutine fgldepthmask
 end interface
 
 interface
 subroutine f9egldepthmask(flag)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: flag
 end subroutine f9egldepthmask
 end interface
 
 interface
 subroutine fgldepthrange(near,far)
 use opengl_kinds
 implicit none
 real(kind=glclampd) ,intent(in) :: near, far
 end subroutine fgldepthrange
 end interface
 
 interface
 subroutine fgldisable(cap)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: cap
 end subroutine fgldisable
 end interface
 
 interface
 subroutine fgldrawbuffer(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fgldrawbuffer
 end interface
 
 interface
 subroutine f9y0gldrawpixels(width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0gldrawpixels
 end interface
 
 interface
 subroutine f9y1gldrawpixels(width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1gldrawpixels
 end interface
 
 interface
 subroutine f9y4gldrawpixels(width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gldrawpixels
 end interface
 
 interface
 subroutine f9y5gldrawpixels(width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5gldrawpixels
 end interface
 
 interface
 subroutine f9y6gldrawpixels(width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6gldrawpixels
 end interface
 
 interface
 subroutine fgledgeflag(flag)
 use opengl_kinds
 implicit none
 logical(kind=glboolean) ,intent(in) :: flag
 end subroutine fgledgeflag
 end interface
 
 interface
 subroutine f9egledgeflag(flag)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: flag
 end subroutine f9egledgeflag
 end interface
 
 interface
 subroutine fgledgeflagv(flag)
 use opengl_kinds
 implicit none
 logical(kind=glboolean), dimension(*) ,intent(in) :: flag
 end subroutine fgledgeflagv
 end interface
 
 interface
 subroutine f9egledgeflagv(flag,length)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: flag
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9egledgeflagv
 end interface
 
 interface
 subroutine fglenable(cap)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: cap
 end subroutine fglenable
 end interface
 
 interface
 subroutine fglend()
 use opengl_kinds
 implicit none
 end subroutine fglend
 end interface
 
 interface
 subroutine fglendlist()
 use opengl_kinds
 implicit none
 end subroutine fglendlist
 end interface
 
 interface
 subroutine fglevalcoord1d(u)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: u
 end subroutine fglevalcoord1d
 end interface
 
 interface
 subroutine fglevalcoord1dv(u)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: u
 end subroutine fglevalcoord1dv
 end interface
 
 interface
 subroutine fglevalcoord1f(u)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: u
 end subroutine fglevalcoord1f
 end interface
 
 interface
 subroutine fglevalcoord1fv(u)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: u
 end subroutine fglevalcoord1fv
 end interface
 
 interface
 subroutine fglevalcoord2d(u,v)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: u, v
 end subroutine fglevalcoord2d
 end interface
 
 interface
 subroutine fglevalcoord2dv(u)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: u
 end subroutine fglevalcoord2dv
 end interface
 
 interface
 subroutine fglevalcoord2f(u,v)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: u, v
 end subroutine fglevalcoord2f
 end interface
 
 interface
 subroutine fglevalcoord2fv(u)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: u
 end subroutine fglevalcoord2fv
 end interface
 
 interface
 subroutine fglevalmesh1(mode,i1,i2)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glint) ,intent(in) :: i1, i2
 end subroutine fglevalmesh1
 end interface
 
 interface
 subroutine fglevalmesh2(mode,i1,i2,j1,j2)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glint) ,intent(in) :: i1, i2, j1, j2
 end subroutine fglevalmesh2
 end interface
 
 interface
 subroutine fglevalpoint1(i)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: i
 end subroutine fglevalpoint1
 end interface
 
 interface
 subroutine fglevalpoint2(i,j)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: i, j
 end subroutine fglevalpoint2
 end interface
 
 interface
 subroutine fglfeedbackbuffer(xsize,xtype,buffer)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 real(kind=glfloat), dimension(*), target, intent(in out) :: buffer
 end subroutine fglfeedbackbuffer
 end interface
 
 interface
 subroutine fglfinish()
 use opengl_kinds
 implicit none
 end subroutine fglfinish
 end interface
 
 interface
 subroutine fglflush()
 use opengl_kinds
 implicit none
 end subroutine fglflush
 end interface
 
 interface
 subroutine fglfogf(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fglfogf
 end interface
 
 interface
 subroutine fglfogfv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fglfogfv
 end interface
 
 interface
 subroutine fglfogi(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fglfogi
 end interface
 
 interface
 subroutine fglfogiv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fglfogiv
 end interface
 
 interface
 subroutine fglfrontface(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglfrontface
 end interface
 
 interface
 subroutine fglfrustum(left,right,bottom,top,near,far)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: left, right, bottom, top, near, far
 end subroutine fglfrustum
 end interface
 
 interface
 function fglgenlists(xrange) result(resfglgenlists)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: xrange
 integer(kind=gluint) :: resfglgenlists
 end function fglgenlists
 end interface
 
 interface
 subroutine fglgetbooleanv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 logical(kind=glboolean), dimension(*), intent(out) :: params
 end subroutine fglgetbooleanv
 end interface
 
 interface
 subroutine f9eglgetbooleanv(pname,params,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint), dimension(*), intent(out) :: params
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9eglgetbooleanv
 end interface
 
 interface
 subroutine fglgetclipplane(plane,equation)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: plane
 real(kind=gldouble), dimension(*), intent(out) :: equation
 end subroutine fglgetclipplane
 end interface
 
 interface
 subroutine fglgetdoublev(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=gldouble), dimension(*), intent(out) :: params
 end subroutine fglgetdoublev
 end interface
 
 interface
 function fglgeterror() result(resfglgeterror)
 use opengl_kinds
 implicit none
 integer(kind=glenum) :: resfglgeterror
 end function fglgeterror
 end interface
 
 interface
 subroutine fglgetfloatv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgetfloatv
 end interface
 
 interface
 subroutine fglgetintegerv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgetintegerv
 end interface
 
 interface
 subroutine fglgetlightfv(light,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgetlightfv
 end interface
 
 interface
 subroutine fglgetlightiv(light,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgetlightiv
 end interface
 
 interface
 subroutine fglgetmapdv(xtarget,query,v)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, query
 real(kind=gldouble), dimension(*), intent(out) :: v
 end subroutine fglgetmapdv
 end interface
 
 interface
 subroutine fglgetmapfv(xtarget,query,v)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, query
 real(kind=glfloat), dimension(*), intent(out) :: v
 end subroutine fglgetmapfv
 end interface
 
 interface
 subroutine fglgetmapiv(xtarget,query,v)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, query
 integer(kind=glint), dimension(*), intent(out) :: v
 end subroutine fglgetmapiv
 end interface
 
 interface
 subroutine fglgetmaterialfv(face,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgetmaterialfv
 end interface
 
 interface
 subroutine fglgetmaterialiv(face,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgetmaterialiv
 end interface
 
 interface
 subroutine fglgetpixelmapfv(map,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 real(kind=glfloat), dimension(*), intent(out) :: values
 end subroutine fglgetpixelmapfv
 end interface
 
 interface
 subroutine fglgetpixelmapuiv(map,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=gluint), dimension(*), intent(out) :: values
 end subroutine fglgetpixelmapuiv
 end interface
 
 interface
 subroutine fglgetpixelmapusv(map,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glushort), dimension(*), intent(out) :: values
 end subroutine fglgetpixelmapusv
 end interface
 
 interface
 subroutine f9aglgetpixelmapusv(map,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glushort), dimension(*), intent(out) :: values
 end subroutine f9aglgetpixelmapusv
 end interface
 
 interface
 subroutine fglgetpolygonstipple(mask,xsize)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*), intent(out) :: mask
 integer(kind=glint) ,intent(in) :: xsize
 end subroutine fglgetpolygonstipple
 end interface
 
 interface
 subroutine f9bglgetpolygonstipple(mask,xsize)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*), intent(out) :: mask
 integer(kind=glint) ,intent(in) :: xsize
 end subroutine f9bglgetpolygonstipple
 end interface
 
 interface
 subroutine f9cglgetpolygonstipple(mask,xsize)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*), intent(out) :: mask
 integer(kind=glint) ,intent(in) :: xsize
 end subroutine f9cglgetpolygonstipple
 end interface
 
 interface
 function f9yglgetstringlen(name) result(resf9yglgetstringlen)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: name
 integer(kind=glint) :: resf9yglgetstringlen
 end function f9yglgetstringlen
 end interface
 
 interface
 subroutine f9yglgetstring(resf9yglgetstring)
 use opengl_kinds
 implicit none
 integer(kind=gluint), intent(out), dimension(*) :: resf9yglgetstring
 end subroutine f9yglgetstring
 end interface
 
 interface
 function f9yglgetstring1(pos) result(resf9yglgetstring1)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: pos
 integer(kind=gluint) :: resf9yglgetstring1
 end function f9yglgetstring1
 end interface
 
 interface
 subroutine f9yglgetstringfree()
 use opengl_kinds
 implicit none
 end subroutine f9yglgetstringfree
 end interface
 
 interface
 subroutine fglgettexenvfv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgettexenvfv
 end interface
 
 interface
 subroutine fglgettexenviv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgettexenviv
 end interface
 
 interface
 subroutine fglgettexgendv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=gldouble), dimension(*), intent(out) :: params
 end subroutine fglgettexgendv
 end interface
 
 interface
 subroutine fglgettexgenfv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgettexgenfv
 end interface
 
 interface
 subroutine fglgettexgeniv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgettexgeniv
 end interface
 
 interface
 subroutine f9y0glgetteximage(xtarget,level,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glgetteximage
 end interface
 
 interface
 subroutine f9y1glgetteximage(xtarget,level,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*), intent(out) :: pixels
 end subroutine f9y1glgetteximage
 end interface
 
 interface
 subroutine f9y4glgetteximage(xtarget,level,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glgetteximage
 end interface
 
 interface
 subroutine f9y5glgetteximage(xtarget,level,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*), intent(out) :: pixels
 end subroutine f9y5glgetteximage
 end interface
 
 interface
 subroutine f9y6glgetteximage(xtarget,level,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glgetteximage
 end interface
 
 interface
 subroutine fglgettexlevelparameterfv(xtarget,level,pname, &
    params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgettexlevelparameterfv
 end interface
 
 interface
 subroutine fglgettexlevelparameteriv(xtarget,level,pname, &
    params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgettexlevelparameteriv
 end interface
 
 interface
 subroutine fglgettexparameterfv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat), dimension(*), intent(out) :: params
 end subroutine fglgettexparameterfv
 end interface
 
 interface
 subroutine fglgettexparameteriv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint), dimension(*), intent(out) :: params
 end subroutine fglgettexparameteriv
 end interface
 
 interface
 subroutine fglhint(xtarget,mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, mode
 end subroutine fglhint
 end interface
 
 interface
 subroutine fglindexmask(mask)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: mask
 end subroutine fglindexmask
 end interface
 
 interface
 subroutine fglindexd(c)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: c
 end subroutine fglindexd
 end interface
 
 interface
 subroutine fglindexdv(c)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: c
 end subroutine fglindexdv
 end interface
 
 interface
 subroutine fglindexf(c)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: c
 end subroutine fglindexf
 end interface
 
 interface
 subroutine fglindexfv(c)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: c
 end subroutine fglindexfv
 end interface
 
 interface
 subroutine fglindexi(c)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: c
 end subroutine fglindexi
 end interface
 
 interface
 subroutine fglindexiv(c)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: c
 end subroutine fglindexiv
 end interface
 
 interface
 subroutine fglindexs(c)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: c
 end subroutine fglindexs
 end interface
 
 interface
 subroutine f9aglindexs(c)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: c
 end subroutine f9aglindexs
 end interface
 
 interface
 subroutine fglindexsv(c)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: c
 end subroutine fglindexsv
 end interface
 
 interface
 subroutine f9aglindexsv(c)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: c
 end subroutine f9aglindexsv
 end interface
 
 interface
 subroutine fglinitnames()
 use opengl_kinds
 implicit none
 end subroutine fglinitnames
 end interface
 
 interface
 function fglisenabled(cap) result(resfglisenabled)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: cap
 logical(kind=glboolean) :: resfglisenabled
 end function fglisenabled
 end interface
 
 interface
 function f9eglisenabled(cap) result(resf9eglisenabled)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: cap
 integer(kind=glint) :: resf9eglisenabled
 end function f9eglisenabled
 end interface
 
 interface
 function fglislist(list) result(resfglislist)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: list
 logical(kind=glboolean) :: resfglislist
 end function fglislist
 end interface
 
 interface
 function f9eglislist(list) result(resf9eglislist)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: list
 integer(kind=glint) :: resf9eglislist
 end function f9eglislist
 end interface
 
 interface
 subroutine fgllightmodelf(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fgllightmodelf
 end interface
 
 interface
 subroutine fgllightmodelfv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fgllightmodelfv
 end interface
 
 interface
 subroutine fgllightmodeli(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fgllightmodeli
 end interface
 
 interface
 subroutine fgllightmodeliv(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fgllightmodeliv
 end interface
 
 interface
 subroutine fgllightf(light,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fgllightf
 end interface
 
 interface
 subroutine fgllightfv(light,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fgllightfv
 end interface
 
 interface
 subroutine fgllighti(light,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fgllighti
 end interface
 
 interface
 subroutine fgllightiv(light,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: light, pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fgllightiv
 end interface
 
 interface
 subroutine fgllinestipple(factor,pattern)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: factor
 integer(kind=glushort) ,intent(in) :: pattern
 end subroutine fgllinestipple
 end interface
 
 interface
 subroutine f9agllinestipple(factor,pattern)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: factor
 integer(kind=glushort) ,intent(in) :: pattern
 end subroutine f9agllinestipple
 end interface
 
 interface
 subroutine fgllinewidth(width)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: width
 end subroutine fgllinewidth
 end interface
 
 interface
 subroutine fgllistbase(base)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: base
 end subroutine fgllistbase
 end interface
 
 interface
 subroutine fglloadidentity()
 use opengl_kinds
 implicit none
 end subroutine fglloadidentity
 end interface
 
 interface
 subroutine fglloadmatrixd(m)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(4,*) ,intent(in) :: m
 end subroutine fglloadmatrixd
 end interface
 
 interface
 subroutine fglloadmatrixf(m)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(4,*) ,intent(in) :: m
 end subroutine fglloadmatrixf
 end interface
 
 interface
 subroutine fglloadname(name)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: name
 end subroutine fglloadname
 end interface
 
 interface
 subroutine fgllogicop(opcode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: opcode
 end subroutine fgllogicop
 end interface
 
 interface
 subroutine fglmap1d(xtarget,u1,u2,stride,order,points)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 real(kind=gldouble) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: stride, order
 real(kind=gldouble), dimension(*) ,intent(in) :: points
 end subroutine fglmap1d
 end interface
 
 interface
 subroutine fglmap1f(xtarget,u1,u2,stride,order,points)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 real(kind=glfloat) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: stride, order
 real(kind=glfloat), dimension(*) ,intent(in) :: points
 end subroutine fglmap1f
 end interface
 
 interface
 subroutine fglmap2d(xtarget,u1,u2,ustride,uorder,v1,v2,vstride, &
    vorder,points)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 real(kind=gldouble) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: ustride, uorder
 real(kind=gldouble) ,intent(in) :: v1, v2
 integer(kind=glint) ,intent(in) :: vstride, vorder
 real(kind=gldouble), dimension(*) ,intent(in) :: points
 end subroutine fglmap2d
 end interface
 
 interface
 subroutine fglmap2f(xtarget,u1,u2,ustride,uorder,v1,v2,vstride, &
    vorder,points)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 real(kind=glfloat) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: ustride, uorder
 real(kind=glfloat) ,intent(in) :: v1, v2
 integer(kind=glint) ,intent(in) :: vstride, vorder
 real(kind=glfloat), dimension(*) ,intent(in) :: points
 end subroutine fglmap2f
 end interface
 
 interface
 subroutine fglmapgrid1d(un,u1,u2)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: un
 real(kind=gldouble) ,intent(in) :: u1, u2
 end subroutine fglmapgrid1d
 end interface
 
 interface
 subroutine fglmapgrid1f(un,u1,u2)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: un
 real(kind=glfloat) ,intent(in) :: u1, u2
 end subroutine fglmapgrid1f
 end interface
 
 interface
 subroutine fglmapgrid2d(un,u1,u2,vn,v1,v2)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: un
 real(kind=gldouble) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: vn
 real(kind=gldouble) ,intent(in) :: v1, v2
 end subroutine fglmapgrid2d
 end interface
 
 interface
 subroutine fglmapgrid2f(un,u1,u2,vn,v1,v2)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: un
 real(kind=glfloat) ,intent(in) :: u1, u2
 integer(kind=glint) ,intent(in) :: vn
 real(kind=glfloat) ,intent(in) :: v1, v2
 end subroutine fglmapgrid2f
 end interface
 
 interface
 subroutine fglmaterialf(face,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fglmaterialf
 end interface
 
 interface
 subroutine fglmaterialfv(face,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fglmaterialfv
 end interface
 
 interface
 subroutine fglmateriali(face,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fglmateriali
 end interface
 
 interface
 subroutine fglmaterialiv(face,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fglmaterialiv
 end interface
 
 interface
 subroutine fglmatrixmode(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglmatrixmode
 end interface
 
 interface
 subroutine fglmultmatrixd(m)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(4,*) ,intent(in) :: m
 end subroutine fglmultmatrixd
 end interface
 
 interface
 subroutine fglmultmatrixf(m)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(4,*) ,intent(in) :: m
 end subroutine fglmultmatrixf
 end interface
 
 interface
 subroutine fglnewlist(list,mode)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: list
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglnewlist
 end interface
 
 interface
 subroutine fglnormal3b(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: nx, ny, nz
 end subroutine fglnormal3b
 end interface
 
 interface
 subroutine f9bglnormal3b(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: nx, ny, nz
 end subroutine f9bglnormal3b
 end interface
 
 interface
 subroutine f9cglnormal3b(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glbyte) ,intent(in) :: nx, ny, nz
 end subroutine f9cglnormal3b
 end interface
 
 interface
 subroutine fglnormal3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine fglnormal3bv
 end interface
 
 interface
 subroutine f9bglnormal3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9bglnormal3bv
 end interface
 
 interface
 subroutine f9cglnormal3bv(v)
 use opengl_kinds
 implicit none
 integer(kind=glbyte), dimension(*) ,intent(in) :: v
 end subroutine f9cglnormal3bv
 end interface
 
 interface
 subroutine fglnormal3d(nx,ny,nz)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: nx, ny, nz
 end subroutine fglnormal3d
 end interface
 
 interface
 subroutine fglnormal3dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglnormal3dv
 end interface
 
 interface
 subroutine fglnormal3f(nx,ny,nz)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: nx, ny, nz
 end subroutine fglnormal3f
 end interface
 
 interface
 subroutine fglnormal3fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglnormal3fv
 end interface
 
 interface
 subroutine fglnormal3i(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: nx, ny, nz
 end subroutine fglnormal3i
 end interface
 
 interface
 subroutine fglnormal3iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglnormal3iv
 end interface
 
 interface
 subroutine fglnormal3s(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: nx, ny, nz
 end subroutine fglnormal3s
 end interface
 
 interface
 subroutine f9aglnormal3s(nx,ny,nz)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: nx, ny, nz
 end subroutine f9aglnormal3s
 end interface
 
 interface
 subroutine fglnormal3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglnormal3sv
 end interface
 
 interface
 subroutine f9aglnormal3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglnormal3sv
 end interface
 
 interface
 subroutine fglortho(left,right,bottom,top,near,far)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: left, right, bottom, top, near, far
 end subroutine fglortho
 end interface
 
 interface
 subroutine fglpassthrough(token)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: token
 end subroutine fglpassthrough
 end interface
 
 interface
 subroutine fglpixelmapfv(map,mapsize,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glint) ,intent(in) :: mapsize
 real(kind=glfloat), dimension(*) ,intent(in) :: values
 end subroutine fglpixelmapfv
 end interface
 
 interface
 subroutine fglpixelmapuiv(map,mapsize,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glint) ,intent(in) :: mapsize
 integer(kind=gluint), dimension(*) ,intent(in) :: values
 end subroutine fglpixelmapuiv
 end interface
 
 interface
 subroutine fglpixelmapusv(map,mapsize,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glint) ,intent(in) :: mapsize
 integer(kind=glushort), dimension(*) ,intent(in) :: values
 end subroutine fglpixelmapusv
 end interface
 
 interface
 subroutine f9aglpixelmapusv(map,mapsize,values)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: map
 integer(kind=glint) ,intent(in) :: mapsize
 integer(kind=glushort), dimension(*) ,intent(in) :: values
 end subroutine f9aglpixelmapusv
 end interface
 
 interface
 subroutine fglpixelstoref(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fglpixelstoref
 end interface
 
 interface
 subroutine fglpixelstorei(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fglpixelstorei
 end interface
 
 interface
 subroutine fglpixeltransferf(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fglpixeltransferf
 end interface
 
 interface
 subroutine fglpixeltransferi(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fglpixeltransferi
 end interface
 
 interface
 subroutine fglpixelzoom(xfactor,yfactor)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: xfactor, yfactor
 end subroutine fglpixelzoom
 end interface
 
 interface
 subroutine fglpointsize(xsize)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: xsize
 end subroutine fglpointsize
 end interface
 
 interface
 subroutine fglpolygonmode(face,mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: face, mode
 end subroutine fglpolygonmode
 end interface
 
 interface
 subroutine fglpolygonstipple(mask)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: mask
 end subroutine fglpolygonstipple
 end interface
 
 interface
 subroutine f9bglpolygonstipple(mask)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: mask
 end subroutine f9bglpolygonstipple
 end interface
 
 interface
 subroutine f9cglpolygonstipple(mask)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: mask
 end subroutine f9cglpolygonstipple
 end interface
 
 interface
 subroutine fglpopattrib()
 use opengl_kinds
 implicit none
 end subroutine fglpopattrib
 end interface
 
 interface
 subroutine fglpopmatrix()
 use opengl_kinds
 implicit none
 end subroutine fglpopmatrix
 end interface
 
 interface
 subroutine fglpopname()
 use opengl_kinds
 implicit none
 end subroutine fglpopname
 end interface
 
 interface
 subroutine fglpushattrib(mask)
 use opengl_kinds
 implicit none
 integer(kind=glbitfield) ,intent(in) :: mask
 end subroutine fglpushattrib
 end interface
 
 interface
 subroutine fglpushmatrix()
 use opengl_kinds
 implicit none
 end subroutine fglpushmatrix
 end interface
 
 interface
 subroutine fglpushname(name)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: name
 end subroutine fglpushname
 end interface
 
 interface
 subroutine fglrasterpos2d(x,y)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y
 end subroutine fglrasterpos2d
 end interface
 
 interface
 subroutine fglrasterpos2dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos2dv
 end interface
 
 interface
 subroutine fglrasterpos2f(x,y)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y
 end subroutine fglrasterpos2f
 end interface
 
 interface
 subroutine fglrasterpos2fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos2fv
 end interface
 
 interface
 subroutine fglrasterpos2i(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 end subroutine fglrasterpos2i
 end interface
 
 interface
 subroutine fglrasterpos2iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos2iv
 end interface
 
 interface
 subroutine fglrasterpos2s(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y
 end subroutine fglrasterpos2s
 end interface
 
 interface
 subroutine f9aglrasterpos2s(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y
 end subroutine f9aglrasterpos2s
 end interface
 
 interface
 subroutine fglrasterpos2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos2sv
 end interface
 
 interface
 subroutine f9aglrasterpos2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglrasterpos2sv
 end interface
 
 interface
 subroutine fglrasterpos3d(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z
 end subroutine fglrasterpos3d
 end interface
 
 interface
 subroutine fglrasterpos3dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos3dv
 end interface
 
 interface
 subroutine fglrasterpos3f(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z
 end subroutine fglrasterpos3f
 end interface
 
 interface
 subroutine fglrasterpos3fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos3fv
 end interface
 
 interface
 subroutine fglrasterpos3i(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y, z
 end subroutine fglrasterpos3i
 end interface
 
 interface
 subroutine fglrasterpos3iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos3iv
 end interface
 
 interface
 subroutine fglrasterpos3s(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z
 end subroutine fglrasterpos3s
 end interface
 
 interface
 subroutine f9aglrasterpos3s(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z
 end subroutine f9aglrasterpos3s
 end interface
 
 interface
 subroutine fglrasterpos3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos3sv
 end interface
 
 interface
 subroutine f9aglrasterpos3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglrasterpos3sv
 end interface
 
 interface
 subroutine fglrasterpos4d(x,y,z,w)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z, w
 end subroutine fglrasterpos4d
 end interface
 
 interface
 subroutine fglrasterpos4dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos4dv
 end interface
 
 interface
 subroutine fglrasterpos4f(x,y,z,w)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z, w
 end subroutine fglrasterpos4f
 end interface
 
 interface
 subroutine fglrasterpos4fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos4fv
 end interface
 
 interface
 subroutine fglrasterpos4i(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y, z, w
 end subroutine fglrasterpos4i
 end interface
 
 interface
 subroutine fglrasterpos4iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos4iv
 end interface
 
 interface
 subroutine fglrasterpos4s(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z, w
 end subroutine fglrasterpos4s
 end interface
 
 interface
 subroutine f9aglrasterpos4s(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z, w
 end subroutine f9aglrasterpos4s
 end interface
 
 interface
 subroutine fglrasterpos4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglrasterpos4sv
 end interface
 
 interface
 subroutine f9aglrasterpos4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglrasterpos4sv
 end interface
 
 interface
 subroutine fglreadbuffer(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglreadbuffer
 end interface
 
 interface
 subroutine f9y0glreadpixels(x,y,width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glreadpixels
 end interface
 
 interface
 subroutine f9y1glreadpixels(x,y,width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*), intent(out) :: pixels
 end subroutine f9y1glreadpixels
 end interface
 
 interface
 subroutine f9y4glreadpixels(x,y,width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glreadpixels
 end interface
 
 interface
 subroutine f9y5glreadpixels(x,y,width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*), intent(out) :: pixels
 end subroutine f9y5glreadpixels
 end interface
 
 interface
 subroutine f9y6glreadpixels(x,y,width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*), intent(out) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glreadpixels
 end interface
 
 interface
 subroutine fglrectd(x1,y1,x2,y2)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x1, y1, x2, y2
 end subroutine fglrectd
 end interface
 
 interface
 subroutine fglrectdv(v1,v2)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v1, v2
 end subroutine fglrectdv
 end interface
 
 interface
 subroutine fglrectf(x1,y1,x2,y2)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x1, y1, x2, y2
 end subroutine fglrectf
 end interface
 
 interface
 subroutine fglrectfv(v1,v2)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v1, v2
 end subroutine fglrectfv
 end interface
 
 interface
 subroutine fglrecti(x1,y1,x2,y2)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x1, y1, x2, y2
 end subroutine fglrecti
 end interface
 
 interface
 subroutine fglrectiv(v1,v2)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v1, v2
 end subroutine fglrectiv
 end interface
 
 interface
 subroutine fglrects(x1,y1,x2,y2)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x1, y1, x2, y2
 end subroutine fglrects
 end interface
 
 interface
 subroutine f9aglrects(x1,y1,x2,y2)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x1, y1, x2, y2
 end subroutine f9aglrects
 end interface
 
 interface
 subroutine fglrectsv(v1,v2)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v1, v2
 end subroutine fglrectsv
 end interface
 
 interface
 subroutine f9aglrectsv(v1,v2)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v1, v2
 end subroutine f9aglrectsv
 end interface
 
 interface
 function fglrendermode(mode) result(resfglrendermode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glint) :: resfglrendermode
 end function fglrendermode
 end interface
 
 interface
 subroutine fglrotated(angle,x,y,z)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: angle, x, y, z
 end subroutine fglrotated
 end interface
 
 interface
 subroutine fglrotatef(angle,x,y,z)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: angle, x, y, z
 end subroutine fglrotatef
 end interface
 
 interface
 subroutine fglscaled(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z
 end subroutine fglscaled
 end interface
 
 interface
 subroutine fglscalef(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z
 end subroutine fglscalef
 end interface
 
 interface
 subroutine fglscissor(x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 end subroutine fglscissor
 end interface
 
 interface
 subroutine fglselectbuffer(xsize,buffer)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: xsize
 integer(kind=gluint), dimension(*), target, intent(in out) :: buffer
 end subroutine fglselectbuffer
 end interface
 
 interface
 subroutine fglshademodel(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglshademodel
 end interface
 
 interface
 subroutine fglstencilfunc(func,ref,mask)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: func
 integer(kind=glint) ,intent(in) :: ref
 integer(kind=gluint) ,intent(in) :: mask
 end subroutine fglstencilfunc
 end interface
 
 interface
 subroutine fglstencilmask(mask)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: mask
 end subroutine fglstencilmask
 end interface
 
 interface
 subroutine fglstencilop(fail,zfail,zpass)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: fail, zfail, zpass
 end subroutine fglstencilop
 end interface
 
 interface
 subroutine fgltexcoord1d(s)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: s
 end subroutine fgltexcoord1d
 end interface
 
 interface
 subroutine fgltexcoord1dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord1dv
 end interface
 
 interface
 subroutine fgltexcoord1f(s)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: s
 end subroutine fgltexcoord1f
 end interface
 
 interface
 subroutine fgltexcoord1fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord1fv
 end interface
 
 interface
 subroutine fgltexcoord1i(s)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: s
 end subroutine fgltexcoord1i
 end interface
 
 interface
 subroutine fgltexcoord1iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord1iv
 end interface
 
 interface
 subroutine fgltexcoord1s(s)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s
 end subroutine fgltexcoord1s
 end interface
 
 interface
 subroutine f9agltexcoord1s(s)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s
 end subroutine f9agltexcoord1s
 end interface
 
 interface
 subroutine fgltexcoord1sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord1sv
 end interface
 
 interface
 subroutine f9agltexcoord1sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9agltexcoord1sv
 end interface
 
 interface
 subroutine fgltexcoord2d(s,t)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: s, t
 end subroutine fgltexcoord2d
 end interface
 
 interface
 subroutine fgltexcoord2dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord2dv
 end interface
 
 interface
 subroutine fgltexcoord2f(s,t)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: s, t
 end subroutine fgltexcoord2f
 end interface
 
 interface
 subroutine fgltexcoord2fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord2fv
 end interface
 
 interface
 subroutine fgltexcoord2i(s,t)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: s, t
 end subroutine fgltexcoord2i
 end interface
 
 interface
 subroutine fgltexcoord2iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord2iv
 end interface
 
 interface
 subroutine fgltexcoord2s(s,t)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t
 end subroutine fgltexcoord2s
 end interface
 
 interface
 subroutine f9agltexcoord2s(s,t)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t
 end subroutine f9agltexcoord2s
 end interface
 
 interface
 subroutine fgltexcoord2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord2sv
 end interface
 
 interface
 subroutine f9agltexcoord2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9agltexcoord2sv
 end interface
 
 interface
 subroutine fgltexcoord3d(s,t,r)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: s, t, r
 end subroutine fgltexcoord3d
 end interface
 
 interface
 subroutine fgltexcoord3dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord3dv
 end interface
 
 interface
 subroutine fgltexcoord3f(s,t,r)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: s, t, r
 end subroutine fgltexcoord3f
 end interface
 
 interface
 subroutine fgltexcoord3fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord3fv
 end interface
 
 interface
 subroutine fgltexcoord3i(s,t,r)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: s, t, r
 end subroutine fgltexcoord3i
 end interface
 
 interface
 subroutine fgltexcoord3iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord3iv
 end interface
 
 interface
 subroutine fgltexcoord3s(s,t,r)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t, r
 end subroutine fgltexcoord3s
 end interface
 
 interface
 subroutine f9agltexcoord3s(s,t,r)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t, r
 end subroutine f9agltexcoord3s
 end interface
 
 interface
 subroutine fgltexcoord3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord3sv
 end interface
 
 interface
 subroutine f9agltexcoord3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9agltexcoord3sv
 end interface
 
 interface
 subroutine fgltexcoord4d(s,t,r,q)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: s, t, r, q
 end subroutine fgltexcoord4d
 end interface
 
 interface
 subroutine fgltexcoord4dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord4dv
 end interface
 
 interface
 subroutine fgltexcoord4f(s,t,r,q)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: s, t, r, q
 end subroutine fgltexcoord4f
 end interface
 
 interface
 subroutine fgltexcoord4fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord4fv
 end interface
 
 interface
 subroutine fgltexcoord4i(s,t,r,q)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: s, t, r, q
 end subroutine fgltexcoord4i
 end interface
 
 interface
 subroutine fgltexcoord4iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord4iv
 end interface
 
 interface
 subroutine fgltexcoord4s(s,t,r,q)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t, r, q
 end subroutine fgltexcoord4s
 end interface
 
 interface
 subroutine f9agltexcoord4s(s,t,r,q)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: s, t, r, q
 end subroutine f9agltexcoord4s
 end interface
 
 interface
 subroutine fgltexcoord4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fgltexcoord4sv
 end interface
 
 interface
 subroutine f9agltexcoord4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9agltexcoord4sv
 end interface
 
 interface
 subroutine fgltexenvf(xtarget,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fgltexenvf
 end interface
 
 interface
 subroutine fgltexenvfv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fgltexenvfv
 end interface
 
 interface
 subroutine fgltexenvi(xtarget,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fgltexenvi
 end interface
 
 interface
 subroutine fgltexenviv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fgltexenviv
 end interface
 
 interface
 subroutine fgltexgend(coord,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=gldouble) ,intent(in) :: param
 end subroutine fgltexgend
 end interface
 
 interface
 subroutine fgltexgendv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=gldouble), dimension(*) ,intent(in) :: params
 end subroutine fgltexgendv
 end interface
 
 interface
 subroutine fgltexgenf(coord,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fgltexgenf
 end interface
 
 interface
 subroutine fgltexgenfv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fgltexgenfv
 end interface
 
 interface
 subroutine fgltexgeni(coord,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fgltexgeni
 end interface
 
 interface
 subroutine fgltexgeniv(coord,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: coord, pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fgltexgeniv
 end interface
 
 interface
 subroutine f9y0glteximage1d(xtarget,level,components,width,border,format,xtype, &
    pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glteximage1d
 end interface
 
 interface
 subroutine f9y1glteximage1d(xtarget,level,components,width,border,format,xtype, &
    pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1glteximage1d
 end interface
 
 interface
 subroutine f9y4glteximage1d(xtarget,level,components,width,border,format,xtype, &
    pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glteximage1d
 end interface
 
 interface
 subroutine f9y5glteximage1d(xtarget,level,components,width,border,format,xtype, &
    pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5glteximage1d
 end interface
 
 interface
 subroutine f9y6glteximage1d(xtarget,level,components,width,border,format,xtype, &
    pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glteximage1d
 end interface
 
 interface
 subroutine f9y0glteximage2d(xtarget,level,components,width,height,border, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glteximage2d
 end interface
 
 interface
 subroutine f9y1glteximage2d(xtarget,level,components,width,height,border, &
    format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1glteximage2d
 end interface
 
 interface
 subroutine f9y4glteximage2d(xtarget,level,components,width,height,border, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glteximage2d
 end interface
 
 interface
 subroutine f9y5glteximage2d(xtarget,level,components,width,height,border, &
    format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5glteximage2d
 end interface
 
 interface
 subroutine f9y6glteximage2d(xtarget,level,components,width,height,border, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, components
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glteximage2d
 end interface
 
 interface
 subroutine fgltexparameterf(xtarget,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fgltexparameterf
 end interface
 
 interface
 subroutine fgltexparameterfv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fgltexparameterfv
 end interface
 
 interface
 subroutine fgltexparameteri(xtarget,pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint) ,intent(in) :: param
 end subroutine fgltexparameteri
 end interface
 
 interface
 subroutine fgltexparameteriv(xtarget,pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget, pname
 integer(kind=glint), dimension(*) ,intent(in) :: params
 end subroutine fgltexparameteriv
 end interface
 
 interface
 subroutine fgltranslated(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z
 end subroutine fgltranslated
 end interface
 
 interface
 subroutine fgltranslatef(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z
 end subroutine fgltranslatef
 end interface
 
 interface
 subroutine fglvertex2d(x,y)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y
 end subroutine fglvertex2d
 end interface
 
 interface
 subroutine fglvertex2dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglvertex2dv
 end interface
 
 interface
 subroutine fglvertex2f(x,y)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y
 end subroutine fglvertex2f
 end interface
 
 interface
 subroutine fglvertex2fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglvertex2fv
 end interface
 
 interface
 subroutine fglvertex2i(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 end subroutine fglvertex2i
 end interface
 
 interface
 subroutine fglvertex2iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglvertex2iv
 end interface
 
 interface
 subroutine fglvertex2s(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y
 end subroutine fglvertex2s
 end interface
 
 interface
 subroutine f9aglvertex2s(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y
 end subroutine f9aglvertex2s
 end interface
 
 interface
 subroutine fglvertex2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglvertex2sv
 end interface
 
 interface
 subroutine f9aglvertex2sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglvertex2sv
 end interface
 
 interface
 subroutine fglvertex3d(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z
 end subroutine fglvertex3d
 end interface
 
 interface
 subroutine fglvertex3dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglvertex3dv
 end interface
 
 interface
 subroutine fglvertex3f(x,y,z)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z
 end subroutine fglvertex3f
 end interface
 
 interface
 subroutine fglvertex3fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglvertex3fv
 end interface
 
 interface
 subroutine fglvertex3i(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y, z
 end subroutine fglvertex3i
 end interface
 
 interface
 subroutine fglvertex3iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglvertex3iv
 end interface
 
 interface
 subroutine fglvertex3s(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z
 end subroutine fglvertex3s
 end interface
 
 interface
 subroutine f9aglvertex3s(x,y,z)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z
 end subroutine f9aglvertex3s
 end interface
 
 interface
 subroutine fglvertex3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglvertex3sv
 end interface
 
 interface
 subroutine f9aglvertex3sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglvertex3sv
 end interface
 
 interface
 subroutine fglvertex4d(x,y,z,w)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, z, w
 end subroutine fglvertex4d
 end interface
 
 interface
 subroutine fglvertex4dv(v)
 use opengl_kinds
 implicit none
 real(kind=gldouble), dimension(*) ,intent(in) :: v
 end subroutine fglvertex4dv
 end interface
 
 interface
 subroutine fglvertex4f(x,y,z,w)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: x, y, z, w
 end subroutine fglvertex4f
 end interface
 
 interface
 subroutine fglvertex4fv(v)
 use opengl_kinds
 implicit none
 real(kind=glfloat), dimension(*) ,intent(in) :: v
 end subroutine fglvertex4fv
 end interface
 
 interface
 subroutine fglvertex4i(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y, z, w
 end subroutine fglvertex4i
 end interface
 
 interface
 subroutine fglvertex4iv(v)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: v
 end subroutine fglvertex4iv
 end interface
 
 interface
 subroutine fglvertex4s(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z, w
 end subroutine fglvertex4s
 end interface
 
 interface
 subroutine f9aglvertex4s(x,y,z,w)
 use opengl_kinds
 implicit none
 integer(kind=glshort) ,intent(in) :: x, y, z, w
 end subroutine f9aglvertex4s
 end interface
 
 interface
 subroutine fglvertex4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine fglvertex4sv
 end interface
 
 interface
 subroutine f9aglvertex4sv(v)
 use opengl_kinds
 implicit none
 integer(kind=glshort), dimension(*) ,intent(in) :: v
 end subroutine f9aglvertex4sv
 end interface
 
 interface
 subroutine fglviewport(x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 end subroutine fglviewport
 end interface
 
 ! OpenGL 1.1
 
 
 interface
 function fglaretexturesresident(n,textures, &
    residences) result(resfglaretexturesresident)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 logical(kind=glboolean), dimension(*), intent(out) :: residences
 logical(kind=glboolean) :: resfglaretexturesresident
 end function fglaretexturesresident
 end interface
 
 interface
 function f9eglaretexturesresident(n,textures, &
    residences) result(resf9eglaretexturesresident)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 integer(kind=glint), dimension(*), intent(out) :: residences
 integer(kind=glint) :: resf9eglaretexturesresident
 end function f9eglaretexturesresident
 end interface
 
 interface
 subroutine fglarrayelement(i)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: i
 end subroutine fglarrayelement
 end interface
 
 interface
 subroutine fglbindtexture(xtarget,texture)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=gluint) ,intent(in) :: texture
 end subroutine fglbindtexture
 end interface
 
 interface
 subroutine f9y0glcolorpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glcolorpointer
 end interface
 
 interface
 subroutine f9y1glcolorpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glcolorpointer
 end interface
 
 interface
 subroutine f9y4glcolorpointer(xsize,xtype,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glcolorpointer
 end interface
 
 interface
 subroutine f9y5glcolorpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glbyte), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y5glcolorpointer
 end interface
 
 interface
 subroutine f9y6glcolorpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glcolorpointer
 end interface
 
 interface
 subroutine f9y7glcolorpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glcolorpointer
 end interface
 
 interface
 subroutine fglcopyteximage1d(xtarget,level,internalformat,x,y, &
    width,border)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glint) ,intent(in) :: border
 end subroutine fglcopyteximage1d
 end interface
 
 interface
 subroutine fglcopyteximage2d(xtarget,level,internalformat,x,y, &
    width,height,border)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glint) ,intent(in) :: x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glint) ,intent(in) :: border
 end subroutine fglcopyteximage2d
 end interface
 
 interface
 subroutine fglcopytexsubimage1d(xtarget,level,xoffset,x,y, &
    width)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, x, y
 integer(kind=glsizei) ,intent(in) :: width
 end subroutine fglcopytexsubimage1d
 end interface
 
 interface
 subroutine fglcopytexsubimage2d(xtarget,level,xoffset,yoffset,x, &
    y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 end subroutine fglcopytexsubimage2d
 end interface
 
 interface
 subroutine fgldeletetextures(n,textures)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 end subroutine fgldeletetextures
 end interface
 
 interface
 subroutine fgldisableclientstate(cap)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: cap
 end subroutine fgldisableclientstate
 end interface
 
 interface
 subroutine fgldrawarrays(mode,first,xcount)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glint) ,intent(in) :: first
 integer(kind=glsizei) ,intent(in) :: xcount
 end subroutine fgldrawarrays
 end interface
 
 interface
 subroutine f9y0gldrawelements(mode,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glint), dimension(*) ,intent(in) :: indices
 end subroutine f9y0gldrawelements
 end interface
 
 interface
 subroutine f9y4gldrawelements(mode,xcount,xtype,indices,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: indices
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gldrawelements
 end interface
 
 interface
 subroutine f9y5gldrawelements(mode,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glbyte), dimension(*) ,intent(in) :: indices
 end subroutine f9y5gldrawelements
 end interface
 
 interface
 subroutine f9y6gldrawelements(mode,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glshort), dimension(*) ,intent(in) :: indices
 end subroutine f9y6gldrawelements
 end interface
 
 interface
 subroutine fgledgeflagpointer(stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: stride
 logical(kind=glboolean), dimension(*), target, intent(in out) :: ptr
 end subroutine fgledgeflagpointer
 end interface
 
 interface
 subroutine f9egledgeflagpointer(stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glbyte), dimension(*), target, intent(in out) :: ptr
 end subroutine f9egledgeflagpointer
 end interface
 
 interface
 subroutine fglenableclientstate(cap)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: cap
 end subroutine fglenableclientstate
 end interface
 
 interface
 subroutine fglgentextures(n,textures)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*), intent(out) :: textures
 end subroutine fglgentextures
 end interface
 
 interface
 subroutine fglgetpointerv(pname,params,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=gluint), dimension(*), intent(out) :: params
 integer(kind=glint) ,intent(in) :: length
 end subroutine fglgetpointerv
 end interface
 
 interface
 subroutine f9y0glindexpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glindexpointer
 end interface
 
 interface
 subroutine f9y1glindexpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glindexpointer
 end interface
 
 interface
 subroutine f9y4glindexpointer(xtype,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glindexpointer
 end interface
 
 interface
 subroutine f9y6glindexpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glindexpointer
 end interface
 
 interface
 subroutine f9y7glindexpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glindexpointer
 end interface
 
 interface
 subroutine fglindexub(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: c
 end subroutine fglindexub
 end interface
 
 interface
 subroutine f9bglindexub(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: c
 end subroutine f9bglindexub
 end interface
 
 interface
 subroutine f9cglindexub(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte) ,intent(in) :: c
 end subroutine f9cglindexub
 end interface
 
 interface
 subroutine fglindexubv(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: c
 end subroutine fglindexubv
 end interface
 
 interface
 subroutine f9bglindexubv(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: c
 end subroutine f9bglindexubv
 end interface
 
 interface
 subroutine f9cglindexubv(c)
 use opengl_kinds
 implicit none
 integer(kind=glubyte), dimension(*) ,intent(in) :: c
 end subroutine f9cglindexubv
 end interface
 
 interface
 subroutine f9y0glinterleavedarrays(format,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glinterleavedarrays
 end interface
 
 interface
 subroutine f9y1glinterleavedarrays(format,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*) ,intent(in) :: ptr
 end subroutine f9y1glinterleavedarrays
 end interface
 
 interface
 subroutine f9y4glinterleavedarrays(format,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glinterleavedarrays
 end interface
 
 interface
 subroutine f9y5glinterleavedarrays(format,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glbyte), dimension(*) ,intent(in) :: ptr
 end subroutine f9y5glinterleavedarrays
 end interface
 
 interface
 subroutine f9y6glinterleavedarrays(format,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glinterleavedarrays
 end interface
 
 interface
 function fglistexture(texture) result(resfglistexture)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: texture
 logical(kind=glboolean) :: resfglistexture
 end function fglistexture
 end interface
 
 interface
 function f9eglistexture(texture) result(resf9eglistexture)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: texture
 integer(kind=glint) :: resf9eglistexture
 end function f9eglistexture
 end interface
 
 interface
 subroutine f9y0glnormalpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*) ,intent(in) :: ptr
 end subroutine f9y0glnormalpointer
 end interface
 
 interface
 subroutine f9y1glnormalpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*) ,intent(in) :: ptr
 end subroutine f9y1glnormalpointer
 end interface
 
 interface
 subroutine f9y4glnormalpointer(xtype,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glnormalpointer
 end interface
 
 interface
 subroutine f9y5glnormalpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glbyte), dimension(*) ,intent(in) :: ptr
 end subroutine f9y5glnormalpointer
 end interface
 
 interface
 subroutine f9y6glnormalpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*) ,intent(in) :: ptr
 end subroutine f9y6glnormalpointer
 end interface
 
 interface
 subroutine f9y7glnormalpointer(xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=gldouble), dimension(*) ,intent(in) :: ptr
 end subroutine f9y7glnormalpointer
 end interface
 
 interface
 subroutine fglpolygonoffset(factor,units)
 use opengl_kinds
 implicit none
 real(kind=glfloat) ,intent(in) :: factor, units
 end subroutine fglpolygonoffset
 end interface
 
 interface
 subroutine fglpopclientattrib()
 use opengl_kinds
 implicit none
 end subroutine fglpopclientattrib
 end interface
 
 interface
 subroutine fglprioritizetextures(n,textures,priorities)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 real(kind=glclampf), dimension(*) ,intent(in) :: priorities
 end subroutine fglprioritizetextures
 end interface
 
 interface
 subroutine fglpushclientattrib(mask)
 use opengl_kinds
 implicit none
 integer(kind=glbitfield) ,intent(in) :: mask
 end subroutine fglpushclientattrib
 end interface
 
 interface
 subroutine f9y0gltexcoordpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*) ,intent(in) :: ptr
 end subroutine f9y0gltexcoordpointer
 end interface
 
 interface
 subroutine f9y1gltexcoordpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*) ,intent(in) :: ptr
 end subroutine f9y1gltexcoordpointer
 end interface
 
 interface
 subroutine f9y4gltexcoordpointer(xsize,xtype,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexcoordpointer
 end interface
 
 interface
 subroutine f9y6gltexcoordpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*) ,intent(in) :: ptr
 end subroutine f9y6gltexcoordpointer
 end interface
 
 interface
 subroutine f9y7gltexcoordpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=gldouble), dimension(*) ,intent(in) :: ptr
 end subroutine f9y7gltexcoordpointer
 end interface
 
 interface
 subroutine f9y0gltexsubimage1d(xtarget,level,xoffset,width, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0gltexsubimage1d
 end interface
 
 interface
 subroutine f9y1gltexsubimage1d(xtarget,level,xoffset,width, &
    format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1gltexsubimage1d
 end interface
 
 interface
 subroutine f9y4gltexsubimage1d(xtarget,level,xoffset,width, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexsubimage1d
 end interface
 
 interface
 subroutine f9y5gltexsubimage1d(xtarget,level,xoffset,width, &
    format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5gltexsubimage1d
 end interface
 
 interface
 subroutine f9y6gltexsubimage1d(xtarget,level,xoffset,width, &
    format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6gltexsubimage1d
 end interface
 
 interface
 subroutine f9y0gltexsubimage2d(xtarget,level,xoffset,yoffset, &
    width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0gltexsubimage2d
 end interface
 
 interface
 subroutine f9y1gltexsubimage2d(xtarget,level,xoffset,yoffset, &
    width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1gltexsubimage2d
 end interface
 
 interface
 subroutine f9y4gltexsubimage2d(xtarget,level,xoffset,yoffset, &
    width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexsubimage2d
 end interface
 
 interface
 subroutine f9y5gltexsubimage2d(xtarget,level,xoffset,yoffset, &
    width,height,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5gltexsubimage2d
 end interface
 
 interface
 subroutine f9y6gltexsubimage2d(xtarget,level,xoffset,yoffset, &
    width,height,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6gltexsubimage2d
 end interface
 interface
 subroutine f9y0glvertexpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glint), dimension(*) ,intent(in) :: ptr
 end subroutine f9y0glvertexpointer
 end interface
 
 interface
 subroutine f9y1glvertexpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=glfloat), dimension(*) ,intent(in) :: ptr
 end subroutine f9y1glvertexpointer
 end interface
 
 interface
 subroutine f9y4glvertexpointer(xsize,xtype,stride,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glvertexpointer
 end interface
 
 interface
 subroutine f9y6glvertexpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 integer(kind=glshort), dimension(*) ,intent(in) :: ptr
 end subroutine f9y6glvertexpointer
 end interface
 
 interface
 subroutine f9y7glvertexpointer(xsize,xtype,stride,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride
 real(kind=gldouble), dimension(*) ,intent(in) :: ptr
 end subroutine f9y7glvertexpointer
 end interface
 
 
 ! OpenGL 1.2
 
 
 interface
 subroutine f9y0gldrawrangeelements(mode,start,xend,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=gluint) ,intent(in) :: start, xend
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glint), dimension(*) ,intent(in) :: indices
 end subroutine f9y0gldrawrangeelements
 end interface
 
 interface
 subroutine f9y4gldrawrangeelements(mode,start,xend,xcount,xtype,indices,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=gluint) ,intent(in) :: start, xend
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: indices
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gldrawrangeelements
 end interface
 
 interface
 subroutine f9y5gldrawrangeelements(mode,start,xend,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=gluint) ,intent(in) :: start, xend
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glbyte), dimension(*) ,intent(in) :: indices
 end subroutine f9y5gldrawrangeelements
 end interface
 
 interface
 subroutine f9y6gldrawrangeelements(mode,start,xend,xcount,xtype,indices)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode, xtype
 integer(kind=gluint) ,intent(in) :: start, xend
 integer(kind=glsizei) ,intent(in) :: xcount
 integer(kind=glshort), dimension(*) ,intent(in) :: indices
 end subroutine f9y6gldrawrangeelements
 end interface
 
 interface
 subroutine f9y0glteximage3d(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glteximage3d
 end interface
 
 interface
 subroutine f9y1glteximage3d(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1glteximage3d
 end interface
 
 interface
 subroutine f9y4glteximage3d(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glteximage3d
 end interface
 
 interface
 subroutine f9y5glteximage3d(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5glteximage3d
 end interface
 
 interface
 subroutine f9y6glteximage3d(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glteximage3d
 end interface
 
 interface
 subroutine f9y0gltexsubimage3d(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0gltexsubimage3d
 end interface
 
 interface
 subroutine f9y1gltexsubimage3d(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1gltexsubimage3d
 end interface
 
 interface
 subroutine f9y4gltexsubimage3d(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexsubimage3d
 end interface
 
 interface
 subroutine f9y5gltexsubimage3d(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5gltexsubimage3d
 end interface
 
 interface
 subroutine f9y6gltexsubimage3d(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6gltexsubimage3d
 end interface
 
 interface
 subroutine fglcopytexsubimage3d(xtarget,level,xoffset, &
    yoffset,zoffset,x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset, x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 end subroutine fglcopytexsubimage3d
 end interface
 
 ! EXT_blend_color
 
 
 interface
 subroutine fglblendcolorext(red,green,blue,alpha)
 use opengl_kinds
 implicit none
 real(kind=glclampf) ,intent(in) :: red, green, blue, alpha
 end subroutine fglblendcolorext
 end interface
 
 
 ! EXT_blend_minmax
 
 
 interface
 subroutine fglblendequationext(mode)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 end subroutine fglblendequationext
 end interface
 
 
 ! EXT_color_table
 
 
 ! EXT_point_parameters
 
 
 interface
 subroutine fglpointparameterfext(pname,param)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat) ,intent(in) :: param
 end subroutine fglpointparameterfext
 end interface
 
 interface
 subroutine fglpointparameterfvext(pname,params)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 real(kind=glfloat), dimension(*) ,intent(in) :: params
 end subroutine fglpointparameterfvext
 end interface
 
 
 ! EXT_polygon_offset
 
 
 ! EXT_subtexture
 
 
 ! EXT_texture3D
 
 
 interface
 subroutine f9y0glteximage3dext(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0glteximage3dext
 end interface
 
 interface
 subroutine f9y1glteximage3dext(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1glteximage3dext
 end interface
 
 interface
 subroutine f9y4glteximage3dext(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glteximage3dext
 end interface
 
 interface
 subroutine f9y5glteximage3dext(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5glteximage3dext
 end interface
 
 interface
 subroutine f9y6glteximage3dext(xtarget,level,internalformat, &
    width,height,depth,border,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level
 integer(kind=glenum) ,intent(in) :: internalformat
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glint) ,intent(in) :: border
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6glteximage3dext
 end interface
 
 interface
 subroutine f9y0gltexsubimage3dext(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y0gltexsubimage3dext
 end interface
 
 interface
 subroutine f9y1gltexsubimage3dext(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: pixels
 end subroutine f9y1gltexsubimage3dext
 end interface
 
 interface
 subroutine f9y4gltexsubimage3dext(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexsubimage3dext
 end interface
 
 interface
 subroutine f9y5gltexsubimage3dext(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: pixels
 end subroutine f9y5gltexsubimage3dext
 end interface
 
 interface
 subroutine f9y6gltexsubimage3dext(xtarget,level,xoffset,yoffset, &
    zoffset,width,height,depth,format,xtype,pixels,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset
 integer(kind=glsizei) ,intent(in) :: width, height, depth
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: pixels
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y6gltexsubimage3dext
 end interface
 
 interface
 subroutine fglcopytexsubimage3dext(xtarget,level,xoffset, &
    yoffset,zoffset,x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: level, xoffset, yoffset, zoffset, x, y
 integer(kind=glsizei) ,intent(in) :: width, height
 end subroutine fglcopytexsubimage3dext
 end interface
 
 
 ! EXT_texture_object
 
 
 interface
 subroutine fglgentexturesext(n,textures)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*), intent(out) :: textures
 end subroutine fglgentexturesext
 end interface
 
 interface
 subroutine fgldeletetexturesext(n,textures)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 end subroutine fgldeletetexturesext
 end interface
 
 interface
 subroutine fglbindtextureext(xtarget,texture)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=gluint) ,intent(in) :: texture
 end subroutine fglbindtextureext
 end interface
 
 interface
 subroutine fglprioritizetexturesext(n,textures,priorities)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 real(kind=glclampf), dimension(*) ,intent(in) :: priorities
 end subroutine fglprioritizetexturesext
 end interface
 
 interface
 function fglaretexturesresidentext(n,textures, &
    residences) result(resfglaretexturesresidentext)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 logical(kind=glboolean), dimension(*), intent(out) :: residences
 logical(kind=glboolean) :: resfglaretexturesresidentext
 end function fglaretexturesresidentext
 end interface
 
 interface
 function f9eglaretexturesresidentext(n,textures, &
    residences) result(resf9eglaretexturesresidentext)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: n
 integer(kind=gluint), dimension(*) ,intent(in) :: textures
 integer(kind=glint), dimension(*), intent(out) :: residences
 integer(kind=glint) :: resf9eglaretexturesresidentext
 end function f9eglaretexturesresidentext
 end interface
 
 interface
 function fglistextureext(texture) result(resfglistextureext)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: texture
 logical(kind=glboolean) :: resfglistextureext
 end function fglistextureext
 end interface
 
 interface
 function f9eglistextureext(texture) result(resf9eglistextureext)
 use opengl_kinds
 implicit none
 integer(kind=gluint) ,intent(in) :: texture
 integer(kind=glint) :: resf9eglistextureext
 end function f9eglistextureext
 end interface
 
 
 ! EXT_vertex_array
 
 
 interface
 subroutine f9y0glvertexpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glvertexpointerext
 end interface
 
 interface
 subroutine f9y1glvertexpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glvertexpointerext
 end interface
 
 interface
 subroutine f9y4glvertexpointerext(xsize,xtype,stride,xcount,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glvertexpointerext
 end interface
 
 interface
 subroutine f9y6glvertexpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glvertexpointerext
 end interface
 
 interface
 subroutine f9y7glvertexpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glvertexpointerext
 end interface
 
 interface
 subroutine f9y0glnormalpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glnormalpointerext
 end interface
 
 interface
 subroutine f9y1glnormalpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glnormalpointerext
 end interface
 
 interface
 subroutine f9y4glnormalpointerext(xtype,stride,xcount,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glnormalpointerext
 end interface
 
 interface
 subroutine f9y5glnormalpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glbyte), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y5glnormalpointerext
 end interface
 
 interface
 subroutine f9y6glnormalpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glnormalpointerext
 end interface
 
 interface
 subroutine f9y7glnormalpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glnormalpointerext
 end interface
 
 interface
 subroutine f9y0glcolorpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glcolorpointerext
 end interface
 
 interface
 subroutine f9y1glcolorpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glcolorpointerext
 end interface
 
 interface
 subroutine f9y4glcolorpointerext(xsize,xtype,stride,xcount,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glcolorpointerext
 end interface
 
 interface
 subroutine f9y5glcolorpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glbyte), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y5glcolorpointerext
 end interface
 
 interface
 subroutine f9y6glcolorpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glcolorpointerext
 end interface
 
 interface
 subroutine f9y7glcolorpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glcolorpointerext
 end interface
 
 interface
 subroutine f9y0glindexpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0glindexpointerext
 end interface
 
 interface
 subroutine f9y1glindexpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1glindexpointerext
 end interface
 
 interface
 subroutine f9y4glindexpointerext(xtype,stride,xcount,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4glindexpointerext
 end interface
 
 interface
 subroutine f9y6glindexpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6glindexpointerext
 end interface
 
 interface
 subroutine f9y7glindexpointerext(xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7glindexpointerext
 end interface
 
 interface
 subroutine f9y0gltexcoordpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glint), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y0gltexcoordpointerext
 end interface
 
 interface
 subroutine f9y1gltexcoordpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y1gltexcoordpointerext
 end interface
 
 interface
 subroutine f9y4gltexcoordpointerext(xsize,xtype,stride,xcount,ptr,length)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=gluint), dimension(*) ,intent(in) :: ptr
 integer(kind=glint) ,intent(in) :: length
 end subroutine f9y4gltexcoordpointerext
 end interface
 
 interface
 subroutine f9y6gltexcoordpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glshort), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y6gltexcoordpointerext
 end interface
 
 interface
 subroutine f9y7gltexcoordpointerext(xsize,xtype,stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: xsize
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 real(kind=gldouble), dimension(*), target, intent(in out) :: ptr
 end subroutine f9y7gltexcoordpointerext
 end interface
 
 interface
 subroutine fgledgeflagpointerext(stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 logical(kind=glboolean), dimension(*), target, intent(in out) :: ptr
 end subroutine fgledgeflagpointerext
 end interface
 
 interface
 subroutine f9egledgeflagpointerext(stride,xcount,ptr)
 use opengl_kinds
 implicit none
 integer(kind=glsizei) ,intent(in) :: stride, xcount
 integer(kind=glbyte), dimension(*), target, intent(in out) :: ptr
 end subroutine f9egledgeflagpointerext
 end interface
 
 interface
 subroutine fglgetpointervext(pname,params,length)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pname
 integer(kind=gluint), dimension(*), intent(out) :: params
 integer(kind=glint) ,intent(in) :: length
 end subroutine fglgetpointervext
 end interface
 
 interface
 subroutine fglarrayelementext(i)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: i
 end subroutine fglarrayelementext
 end interface
 
 interface
 subroutine fgldrawarraysext(mode,first,xcount)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glint) ,intent(in) :: first
 integer(kind=glsizei) ,intent(in) :: xcount
 end subroutine fgldrawarraysext
 end interface
 
 
 ! SGIS_multisample
 
 
 ! MESA_resize_buffers
 
 
 ! MESA_window_pos
 
 
 end module opengl_glinterfaces
