 !----------------------------------------------------------------------------
 !
 !                    f90gl version 1.2.12, September 2006
 !
 !     William F. Mitchell
 !     Mathematical and Computational Sciences Division
 !     National Institute of Standards and Technology
 !     william.mitchell@nist.gov
 !     http://math.nist.gov/f90gl
 !
 ! f90gl is public domain software.  It was produced as part of work done by
 ! the U.S. Government, and is not subject to copyright in the United States.
 !
 !----------------------------------------------------------------------------
 
 
 
 module opengl_glu
 
 use opengl_kinds
 use opengl_gluinterfaces
 implicit none
 private
 
 
 
 
 
 
 
 
 
 !--------------------------
 ! Public generic interfaces
 !--------------------------
 
 public :: &
    glubegincurve, &
    glubeginpolygon, &
    glubeginsurface, &
    glubegintrim, &
    glubuild1dmipmaps, &
    glubuild2dmipmaps, &
    glucylinder, &
    gludeletenurbsrenderer, &
    gludeletequadric, &
    gludeletetess, &
    gludisk, &
    gluendcurve, &
    gluendpolygon, &
    gluendsurface, &
    gluendtrim, &
    gluerrorstring, &
    glugetnurbsproperty, &
    glugetstring, &
    glugettessproperty, &
    gluloadsamplingmatrices, &
    glulookat, &
    glunewnurbsrenderer, &
    glunewquadric, &
    glunewtess, &
    glunextcontour
 public :: &
    glunurbscallback, &
    glunurbscurve, &
    glunurbsproperty, &
    glunurbssurface, &
    gluortho2d, &
    glupartialdisk, &
    gluperspective, &
    glupickmatrix, &
    gluproject, &
    glupwlcurve, &
    gluquadriccallback, &
    gluquadricdrawstyle, &
    gluquadricnormals, &
    gluquadricorientation, &
    gluquadrictexture, &
    gluscaleimage, &
    glusphere, &
    glutessbegincontour, &
    glutessbeginpolygon, &
    glutesscallback, &
    glutessendcontour, &
    glutessendpolygon, &
    glutessnormal, &
    glutessproperty, &
    glutessvertex, &
    gluunproject
 
 !-----------------------------------
 ! Public entities from other modules
 !-----------------------------------
 
 ! Some older compilers require that derived types from other modules be made
 ! public if there are public routines with arguments of that type.
 ! F forbids this, and some other compilers issue warnings about double access.
 ! Here we make them public except on those compilers that complain.
 
 
 public :: glcptr
 
 !------------------------
 ! Private module routines
 !------------------------
 
 private :: &
    f9xglubegincurve, &
    f9xglubeginpolygon, &
    f9xglubeginsurface, &
    f9xglubegintrim, &
    f9x0glubuild1dmipmaps, &
    f9x1glubuild1dmipmaps, &
    f9x4glubuild1dmipmaps, &
    f9x5glubuild1dmipmaps, &
    f9x6glubuild1dmipmaps, &
    f9x0glubuild2dmipmaps, &
    f9x1glubuild2dmipmaps, &
    f9x4glubuild2dmipmaps, &
    f9x5glubuild2dmipmaps, &
    f9x6glubuild2dmipmaps, &
    f9xglucylinder, &
    f9xgludeletenurbsrenderer, &
    f9xgludeletequadric, &
    f9xgludeletetess, &
    f9xgludisk, &
    f9xgluendcurve, &
    f9xgluendpolygon, &
    f9xgluendsurface, &
    f9xgluendtrim, &
    f9xgluerrorstring, &
    f9xglugetnurbsproperty, &
    f9xglugetstring, &
    f9xglugettessproperty, &
    f9xgluloadsamplingmatrices, &
    f9xglulookat, &
    f9xglunewnurbsrenderer, &
    f9xglunewquadric, &
    f9xglunewtess, &
    f9xglunextcontour
 private :: &
    f9xglunurbscallback, &
    f9x1glunurbscallback, &
    f9xglunurbscurve, &
    f9xglunurbsproperty, &
    f9xglunurbssurface, &
    f9xgluortho2d, &
    f9xglupartialdisk, &
    f9xgluperspective, &
    f9xglupickmatrix, &
    f9xgluproject, &
    f9xglupwlcurve, &
    f9xgluquadriccallback, &
    f9x1gluquadriccallback, &
    f9xgluquadricdrawstyle, &
    f9xgluquadricnormals, &
    f9xgluquadricorientation, &
    f9xgluquadrictexture, &
    f9x0gluscaleimage, &
    f9x1gluscaleimage, &
    f9x4gluscaleimage, &
    f9x5gluscaleimage, &
    f9x6gluscaleimage, &
    f9xglusphere
 private :: &
    f9x01gluscaleimage, &
    f9x04gluscaleimage, &
    f9x05gluscaleimage, &
    f9x06gluscaleimage, &
    f9x10gluscaleimage, &
    f9x14gluscaleimage, &
    f9x15gluscaleimage, &
    f9x16gluscaleimage, &
    f9x40gluscaleimage, &
    f9x41gluscaleimage, &
    f9x45gluscaleimage, &
    f9x46gluscaleimage, &
    f9x50gluscaleimage, &
    f9x51gluscaleimage, &
    f9x54gluscaleimage, &
    f9x56gluscaleimage, &
    f9x60gluscaleimage, &
    f9x61gluscaleimage, &
    f9x64gluscaleimage, &
    f9x65gluscaleimage
 private :: &
    f9xglutessbegincontour, &
    f9x0glutessbeginpolygon, &
    f9x1glutessbeginpolygon, &
    f9x1glutesscallback, &
    f9x0glutesscallback
 private :: &
    f9xglutessendcontour, &
    f9xglutessendpolygon, &
    f9xglutessnormal, &
    f9xglutessproperty, &
    f9x0glutessvertex, &
    f9x1glutessvertex, &
    f9x4glutessvertex, &
    f9x5glutessvertex, &
    f9x6glutessvertex, &
    f9x7glutessvertex, &
    f9xgluunproject
 
 !------
 ! Types
 !------
 
 type, public :: gluquadricobj
    type(glcptr), dimension(2) :: addr
 end type gluquadricobj
 
 type, public :: glunurbsobj
    type(glcptr), dimension(2) :: addr
 end type glunurbsobj
 
 integer(kind=glint), parameter, private :: num_tess_cb = 12
 type, public :: glutesselator
    type(glcptr), dimension(num_tess_cb+1) :: addr
 end type glutesselator
 
 
 !-------------------
 ! symbolic constants
 !-------------------
 
 integer(kind=glenum), parameter, public :: GLU_FALSE = 0
 integer(kind=glenum), parameter, public :: GLU_TRUE = 1
 integer(kind=glenum), parameter, public :: GLU_VERSION_1_1 = 1
 integer(kind=glenum), parameter, public :: GLU_VERSION_1_2 = 1
 integer(kind=glenum), parameter, public :: GLU_VERSION = 100800
 integer(kind=glenum), parameter, public :: GLU_EXTENSIONS = 100801
 integer(kind=glenum), parameter, public :: GLU_INVALID_ENUM = 100900
 integer(kind=glenum), parameter, public :: GLU_INVALID_VALUE = 100901
 integer(kind=glenum), parameter, public :: GLU_OUT_OF_MEMORY = 100902
 integer(kind=glenum), parameter, public :: GLU_INCOMPATIBLE_GL_VERSION = 100903
 integer(kind=glenum), parameter, public :: GLU_OUTLINE_POLYGON = 100240
 integer(kind=glenum), parameter, public :: GLU_OUTLINE_PATCH = 100241
 integer(kind=glenum), parameter, public :: GLU_ERROR = 100103
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR1 = 100251
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR2 = 100252
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR3 = 100253
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR4 = 100254
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR5 = 100255
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR6 = 100256
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR7 = 100257
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR8 = 100258
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR9 = 100259
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR10 = 100260
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR11 = 100261
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR12 = 100262
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR13 = 100263
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR14 = 100264
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR15 = 100265
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR16 = 100266
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR17 = 100267
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR18 = 100268
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR19 = 100269
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR20 = 100270
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR21 = 100271
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR22 = 100272
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR23 = 100273
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR24 = 100274
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR25 = 100275
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR26 = 100276
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR27 = 100277
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR28 = 100278
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR29 = 100279
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR30 = 100280
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR31 = 100281
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR32 = 100282
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR33 = 100283
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR34 = 100284
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR35 = 100285
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR36 = 100286
 integer(kind=glenum), parameter, public :: GLU_NURBS_ERROR37 = 100287
 integer(kind=glenum), parameter, public :: GLU_AUTO_LOAD_MATRIX = 100200
 integer(kind=glenum), parameter, public :: GLU_CULLING = 100201
 integer(kind=glenum), parameter, public :: GLU_SAMPLING_TOLERANCE = 100203
 integer(kind=glenum), parameter, public :: GLU_DISPLAY_MODE = 100204
 integer(kind=glenum), parameter, public :: GLU_PARAMETRIC_TOLERANCE = 100202
 integer(kind=glenum), parameter, public :: GLU_SAMPLING_METHOD = 100205
 integer(kind=glenum), parameter, public :: GLU_U_STEP = 100206
 integer(kind=glenum), parameter, public :: GLU_V_STEP = 100207
 integer(kind=glenum), parameter, public :: GLU_PATH_LENGTH = 100215
 integer(kind=glenum), parameter, public :: GLU_PARAMETRIC_ERROR = 100216
 integer(kind=glenum), parameter, public :: GLU_DOMAIN_DISTANCE = 100217
 integer(kind=glenum), parameter, public :: GLU_MAP1_TRIM_2 = 100210
 integer(kind=glenum), parameter, public :: GLU_MAP1_TRIM_3 = 100211
 integer(kind=glenum), parameter, public :: GLU_POINT = 100010
 integer(kind=glenum), parameter, public :: GLU_LINE = 100011
 integer(kind=glenum), parameter, public :: GLU_FILL = 100012
 integer(kind=glenum), parameter, public :: GLU_SILHOUETTE = 100013
 integer(kind=glenum), parameter, public :: GLU_SMOOTH = 100000
 integer(kind=glenum), parameter, public :: GLU_FLAT = 100001
 integer(kind=glenum), parameter, public :: GLU_NONE = 100002
 integer(kind=glenum), parameter, public :: GLU_OUTSIDE = 100020
 integer(kind=glenum), parameter, public :: GLU_INSIDE = 100021
 integer(kind=glenum), parameter, public :: GLU_BEGIN = 100100
 integer(kind=glenum), parameter, public :: GLU_VERTEX = 100101
 integer(kind=glenum), parameter, public :: GLU_END = 100102
 integer(kind=glenum), parameter, public :: GLU_EDGE_FLAG = 100104
 integer(kind=glenum), parameter, public :: GLU_TESS_BEGIN = 100100
 integer(kind=glenum), parameter, public :: GLU_TESS_VERTEX = 100101
 integer(kind=glenum), parameter, public :: GLU_TESS_END = 100102
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR = 100103
 integer(kind=glenum), parameter, public :: GLU_TESS_EDGE_FLAG = 100104
 integer(kind=glenum), parameter, public :: GLU_TESS_COMBINE = 100105
 integer(kind=glenum), parameter, public :: GLU_TESS_BEGIN_DATA = 100106
 integer(kind=glenum), parameter, public :: GLU_TESS_VERTEX_DATA = 100107
 integer(kind=glenum), parameter, public :: GLU_TESS_END_DATA = 100108
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR_DATA = 100109
 integer(kind=glenum), parameter, public :: GLU_TESS_EDGE_FLAG_DATA = 100110
 integer(kind=glenum), parameter, public :: GLU_TESS_COMBINE_DATA = 100111
 integer(kind=glenum), parameter, public :: GLU_CW = 100120
 integer(kind=glenum), parameter, public :: GLU_CCW = 100121
 integer(kind=glenum), parameter, public :: GLU_INTERIOR = 100122
 integer(kind=glenum), parameter, public :: GLU_EXTERIOR = 100123
 integer(kind=glenum), parameter, public :: GLU_UNKNOWN = 100124
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_RULE = 100140
 integer(kind=glenum), parameter, public :: GLU_TESS_BOUNDARY_ONLY = 100141
 integer(kind=glenum), parameter, public :: GLU_TESS_TOLERANCE = 100142
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR1 = 100151
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR2 = 100152
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR3 = 100153
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR4 = 100154
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR5 = 100155
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR6 = 100156
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR7 = 100157
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR8 = 100158
 integer(kind=glenum), parameter, public :: GLU_TESS_ERROR9 = 100159
 integer(kind=glenum), parameter, public :: GLU_TESS_MISSING_BEGIN_POLYGON=100151
 integer(kind=glenum), parameter, public :: GLU_TESS_MISSING_BEGIN_CONTOUR=100152
 integer(kind=glenum), parameter, public :: GLU_TESS_MISSING_END_POLYGON = 100153
 integer(kind=glenum), parameter, public :: GLU_TESS_MISSING_END_CONTOUR = 100154
 integer(kind=glenum), parameter, public :: GLU_TESS_COORD_TOO_LARGE = 100155
 integer(kind=glenum), parameter, public :: GLU_TESS_NEED_COMBINE_CALLBACK=100156
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_ODD = 100130
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_NONZERO = 100131
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_POSITIVE = 100132
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_NEGATIVE = 100133
 integer(kind=glenum), parameter, public :: GLU_TESS_WINDING_ABS_GEQ_TWO = 100134
 integer(kind=glint), parameter, public :: GLUNULLFUNC = 1
 
 ! interface blocks
 
 
 interface glubegincurve
    module procedure f9xglubegincurve
 end interface
 
 interface glubeginpolygon
    module procedure f9xglubeginpolygon
 end interface
 
 interface glubeginsurface
    module procedure f9xglubeginsurface
 end interface
 
 interface glubegintrim
    module procedure f9xglubegintrim
 end interface
 
 interface glubuild1dmipmaps
    module procedure f9x0glubuild1dmipmaps
    module procedure f9x1glubuild1dmipmaps
    module procedure f9x4glubuild1dmipmaps
    module procedure f9x5glubuild1dmipmaps
    module procedure f9x6glubuild1dmipmaps
 end interface
 
 interface glubuild2dmipmaps
    module procedure f9x0glubuild2dmipmaps
    module procedure f9x1glubuild2dmipmaps
    module procedure f9x4glubuild2dmipmaps
    module procedure f9x5glubuild2dmipmaps
    module procedure f9x6glubuild2dmipmaps
 end interface
 
 interface glucylinder
    module procedure f9xglucylinder
 end interface
 
 interface gludeletenurbsrenderer
    module procedure f9xgludeletenurbsrenderer
 end interface
 
 interface gludeletequadric
    module procedure f9xgludeletequadric
 end interface
 
 interface gludeletetess
    module procedure f9xgludeletetess
 end interface
 
 interface gludisk
    module procedure f9xgludisk
 end interface
 
 interface gluendcurve
    module procedure f9xgluendcurve
 end interface
 
 interface gluendpolygon
    module procedure f9xgluendpolygon
 end interface
 
 interface gluendsurface
    module procedure f9xgluendsurface
 end interface
 
 interface gluendtrim
    module procedure f9xgluendtrim
 end interface
 
 interface gluerrorstring
    module procedure f9xgluerrorstring
 end interface
 
 interface glugetnurbsproperty
    module procedure f9xglugetnurbsproperty
 end interface
 
 interface glugetstring
    module procedure f9xglugetstring
 end interface
 
 interface glugettessproperty
    module procedure f9xglugettessproperty
 end interface
 
 interface gluloadsamplingmatrices
    module procedure f9xgluloadsamplingmatrices
 end interface
 
 interface glulookat
    module procedure f9xglulookat
 end interface
 
 interface glunewnurbsrenderer
    module procedure f9xglunewnurbsrenderer
 end interface
 
 interface glunewquadric
    module procedure f9xglunewquadric
 end interface
 
 interface glunewtess
    module procedure f9xglunewtess
 end interface
 
 interface glunextcontour
    module procedure f9xglunextcontour
 end interface
 
 interface glunurbscallback
    module procedure f9xglunurbscallback
    module procedure f9x1glunurbscallback
 end interface
 
 interface glunurbscurve
    module procedure f9xglunurbscurve
 end interface
 
 interface glunurbsproperty
    module procedure f9xglunurbsproperty
 end interface
 
 interface glunurbssurface
    module procedure f9xglunurbssurface
 end interface
 
 interface gluortho2d
    module procedure f9xgluortho2d
 end interface
 
 interface glupartialdisk
    module procedure f9xglupartialdisk
 end interface
 
 interface gluperspective
    module procedure f9xgluperspective
 end interface
 
 interface glupickmatrix
    module procedure f9xglupickmatrix
 end interface
 
 interface gluproject
    module procedure f9xgluproject
 end interface
 
 interface glupwlcurve
    module procedure f9xglupwlcurve
 end interface
 
 interface gluquadriccallback
    module procedure f9xgluquadriccallback
    module procedure f9x1gluquadriccallback
 end interface
 
 interface gluquadricdrawstyle
    module procedure f9xgluquadricdrawstyle
 end interface
 
 interface gluquadricnormals
    module procedure f9xgluquadricnormals
 end interface
 
 interface gluquadricorientation
    module procedure f9xgluquadricorientation
 end interface
 
 interface gluquadrictexture
    module procedure f9xgluquadrictexture
 end interface
 
 interface gluscaleimage
    module procedure f9x0gluscaleimage
    module procedure f9x1gluscaleimage
    module procedure f9x4gluscaleimage
    module procedure f9x5gluscaleimage
    module procedure f9x6gluscaleimage
    module procedure f9x01gluscaleimage
    module procedure f9x04gluscaleimage
    module procedure f9x05gluscaleimage
    module procedure f9x06gluscaleimage
    module procedure f9x10gluscaleimage
    module procedure f9x14gluscaleimage
    module procedure f9x15gluscaleimage
    module procedure f9x16gluscaleimage
    module procedure f9x40gluscaleimage
    module procedure f9x41gluscaleimage
    module procedure f9x45gluscaleimage
    module procedure f9x46gluscaleimage
    module procedure f9x50gluscaleimage
    module procedure f9x51gluscaleimage
    module procedure f9x54gluscaleimage
    module procedure f9x56gluscaleimage
    module procedure f9x60gluscaleimage
    module procedure f9x61gluscaleimage
    module procedure f9x64gluscaleimage
    module procedure f9x65gluscaleimage
 end interface
 
 interface glusphere
    module procedure f9xglusphere
 end interface
 
 interface glutessbegincontour
    module procedure f9xglutessbegincontour
 end interface
 
 interface glutessbeginpolygon
    module procedure f9x0glutessbeginpolygon
    module procedure f9x1glutessbeginpolygon
 end interface
 
 interface glutesscallback
    module procedure f9x0glutesscallback
    module procedure f9x1glutesscallback
 end interface
 
 interface glutessendcontour
    module procedure f9xglutessendcontour
 end interface
 
 interface glutessendpolygon
    module procedure f9xglutessendpolygon
 end interface
 
 interface glutessnormal
    module procedure f9xglutessnormal
 end interface
 
 interface glutessproperty
    module procedure f9xglutessproperty
 end interface
 
 interface glutessvertex
    module procedure f9x0glutessvertex
    module procedure f9x1glutessvertex
    module procedure f9x4glutessvertex
    module procedure f9x5glutessvertex
    module procedure f9x6glutessvertex
    module procedure f9x7glutessvertex
 end interface
 
 interface gluunproject
    module procedure f9xgluunproject
 end interface
 
 interface size_glint
    module procedure size_glint_glint
    module procedure size_glint_glshort
    module procedure size_glint_glbyte
    module procedure size_glint_glfloat
 end interface
 
 contains
 
 function size_glint_glint(a) result(ressize_glint)
 integer(kind=glint), dimension(:) ,intent(in) :: a
 integer(kind=glint) :: ressize_glint
 ressize_glint = size(a)
 end function size_glint_glint
 
 function size_glint_glshort(a) result(ressize_glint)
 integer(kind=glshort), dimension(:) ,intent(in) :: a
 integer(kind=glint) :: ressize_glint
 ressize_glint = size(a)
 end function size_glint_glshort
 
 function size_glint_glbyte(a) result(ressize_glint)
 integer(kind=glbyte), dimension(:) ,intent(in) :: a
 integer(kind=glint) :: ressize_glint
 ressize_glint = size(a)
 end function size_glint_glbyte
 
 function size_glint_glfloat(a) result(ressize_glint)
 real(kind=glfloat), dimension(:) ,intent(in) :: a
 integer(kind=glint) :: ressize_glint
 ressize_glint = size(a)
 end function size_glint_glfloat
 
 
 subroutine f9xglubegincurve(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglubegincurve(temp,i)
 return
 end subroutine f9xglubegincurve
 
 subroutine f9xglubeginpolygon(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglubeginpolygon(temp,i)
 return
 end subroutine f9xglubeginpolygon
 
 subroutine f9xglubeginsurface(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglubeginsurface(temp,i)
 return
 end subroutine f9xglubeginsurface
 
 subroutine f9xglubegintrim(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglubegintrim(temp,i)
 return
 end subroutine f9xglubegintrim
 
 function f9x0glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9x0glubuild1dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: data
 integer(kind=glint) :: resf9x0glubuild1dmipmaps
 resf9x0glubuild1dmipmaps = f9y0glubuild1dmipmaps(xtarget,component,width, &
    format,xtype,data,size_glint(data))
 return
 end function f9x0glubuild1dmipmaps
 
 function f9x1glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9x1glubuild1dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9x1glubuild1dmipmaps
 resf9x1glubuild1dmipmaps = f9y1glubuild1dmipmaps(xtarget,component,width, &
    format,xtype,data)
 return
 end function f9x1glubuild1dmipmaps
 
 function f9x4glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9x4glubuild1dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 type(glcptr) ,intent(in) :: data
 integer(kind=glint) :: resf9x4glubuild1dmipmaps
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(data%addr(i:i))
 end do
 i = glcptr_length
 resf9x4glubuild1dmipmaps = f9y4glubuild1dmipmaps(xtarget,component,width, &
    format,xtype,temp,i)
 return
 end function f9x4glubuild1dmipmaps
 
 function f9x5glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9x5glubuild1dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9x5glubuild1dmipmaps
 resf9x5glubuild1dmipmaps = f9y5glubuild1dmipmaps(xtarget,component,width, &
    format,xtype,data)
 return
 end function f9x5glubuild1dmipmaps
 
 function f9x6glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9x6glubuild1dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: data
 integer(kind=glint) :: resf9x6glubuild1dmipmaps
 resf9x6glubuild1dmipmaps = f9y6glubuild1dmipmaps(xtarget,component,width, &
    format,xtype,data,size_glint(data))
 return
 end function f9x6glubuild1dmipmaps
 
 function f9x0glubuild2dmipmaps(xtarget,component,width,height, &
    format,xtype,data) result(resf9x0glubuild2dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: data
 integer(kind=glint) :: resf9x0glubuild2dmipmaps
 resf9x0glubuild2dmipmaps = f9y0glubuild2dmipmaps(xtarget,component,width, &
    height,format,xtype,data,size_glint(data))
 return
 end function f9x0glubuild2dmipmaps
 
 function f9x1glubuild2dmipmaps(xtarget,component,width,height, &
    format,xtype,data) result(resf9x1glubuild2dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9x1glubuild2dmipmaps
 resf9x1glubuild2dmipmaps = f9y1glubuild2dmipmaps(xtarget,component,width, &
    height,format,xtype,data)
 return
 end function f9x1glubuild2dmipmaps
 
 function f9x4glubuild2dmipmaps(xtarget,component,width,height, &
    format,xtype,data) result(resf9x4glubuild2dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 type(glcptr) ,intent(in) :: data
 integer(kind=glint) :: resf9x4glubuild2dmipmaps
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(data%addr(i:i))
 end do
 i = glcptr_length
 resf9x4glubuild2dmipmaps = f9y4glubuild2dmipmaps(xtarget,component,width, &
    height,format,xtype,temp,i)
 return
 end function f9x4glubuild2dmipmaps
 
 function f9x5glubuild2dmipmaps(xtarget,component,width,height, &
    format,xtype,data) result(resf9x5glubuild2dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9x5glubuild2dmipmaps
 resf9x5glubuild2dmipmaps = f9y5glubuild2dmipmaps(xtarget,component,width, &
    height,format,xtype,data)
 return
 end function f9x5glubuild2dmipmaps
 
 function f9x6glubuild2dmipmaps(xtarget,component,width,height, &
    format,xtype,data) result(resf9x6glubuild2dmipmaps)
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width, height
 integer(kind=glenum) ,intent(in) :: format, xtype
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: data
 integer(kind=glint) :: resf9x6glubuild2dmipmaps
 resf9x6glubuild2dmipmaps = f9y6glubuild2dmipmaps(xtarget,component,width, &
    height,format,xtype,data,size_glint(data))
 return
 end function f9x6glubuild2dmipmaps
 
 subroutine f9xglucylinder(quad,base,top,height,slices,stacks)
 type(gluquadricobj), pointer :: quad
 real(kind=gldouble) ,intent(in) :: base, top, height
 integer(kind=glint) ,intent(in) :: slices, stacks
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglucylinder(temp,i,base,top,height,slices,stacks)
 return
 end subroutine f9xglucylinder
 
 subroutine f9xgludeletenurbsrenderer(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgludeletenurbsrenderer(temp,i)
 deallocate(nurb)
 return
 end subroutine f9xgludeletenurbsrenderer
 
 subroutine f9xgludeletequadric(quad)
 type(gluquadricobj), pointer :: quad
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgludeletequadric(temp,i)
 deallocate(quad)
 return
 end subroutine f9xgludeletequadric
 
 subroutine f9xgludeletetess(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fgludeletetess(temp,i)
 deallocate(tess)
 return
 end subroutine f9xgludeletetess
 
 subroutine f9xgludisk(quad,inner,outer,slices,loops)
 type(gluquadricobj), pointer :: quad
 real(kind=gldouble) ,intent(in) :: inner, outer
 integer(kind=glint) ,intent(in) :: slices, loops
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgludisk(temp,i,inner,outer,slices,loops)
 return
 end subroutine f9xgludisk
 
 subroutine f9xgluendcurve(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluendcurve(temp,i)
 return
 end subroutine f9xgluendcurve
 
 subroutine f9xgluendpolygon(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fgluendpolygon(temp,i)
 return
 end subroutine f9xgluendpolygon
 
 subroutine f9xgluendsurface(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluendsurface(temp,i)
 return
 end subroutine f9xgluendsurface
 
 subroutine f9xgluendtrim(nurb)
 type(glunurbsobj), pointer :: nurb
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluendtrim(temp,i)
 return
 end subroutine f9xgluendtrim
 
 function f9xgluerrorstring(error) result(resf9xgluerrorstring)
 integer(kind=glenum) ,intent(in) :: error
 character(len=1), pointer, dimension(:) :: resf9xgluerrorstring
 integer(kind=gluint), allocatable, dimension(:) :: temp
 integer(kind=glint) :: length, pos
 length = f9ygluerrorstringlen(error)
 allocate(temp(length))
 allocate(resf9xgluerrorstring(length))
 call f9yglugetstring(temp)
 do pos=1,length
    resf9xgluerrorstring(pos) = char(temp(pos))
 end do
 call f9yglugetstringfree()
 deallocate(temp)
 return
 end function f9xgluerrorstring
 
 subroutine f9xglugetnurbsproperty(nurb,property,data)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glenum) ,intent(in) :: property
 real(kind=glfloat), intent(out) :: data
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglugetnurbsproperty(temp,i,property,data)
 return
 end subroutine f9xglugetnurbsproperty
 
 function f9xglugetstring(name) result(resf9xglugetstring)
 integer(kind=glenum) ,intent(in) :: name
 character(len=1), pointer, dimension(:) :: resf9xglugetstring
 integer(kind=gluint), allocatable, dimension(:) :: temp
 integer(kind=glint) :: length, pos
 length = f9yglugetstringlen(name)
 allocate(temp(length))
 allocate(resf9xglugetstring(length))
 call f9yglugetstring(temp)
 do pos=1,length
    resf9xglugetstring(pos) = char(temp(pos))
 end do
 call f9yglugetstringfree()
 deallocate(temp)
 return
 end function f9xglugetstring
 
 subroutine f9xglugettessproperty(tess,which,data)
 type(glutesselator), pointer :: tess
 integer(kind=glenum) ,intent(in) :: which
 real(kind=gldouble), intent(out) :: data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglugettessproperty(temp,i,which,data)
 return
 end subroutine f9xglugettessproperty
 
 subroutine f9xgluloadsamplingmatrices(nurb,model,perspective,view)
 type(glunurbsobj), pointer :: nurb
 real(kind=glfloat), dimension(*) ,intent(in) :: model, perspective
 integer(kind=glint), dimension(*) ,intent(in) :: view
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluloadsamplingmatrices(temp,i,model,perspective,view)
 return
 end subroutine f9xgluloadsamplingmatrices
 
 subroutine f9xglulookat(eyex,eyey,eyez,centerx,centery,centerz,upx,upy,upz)
 real(kind=gldouble) ,intent(in) :: eyex, eyey, eyez, centerx, centery, centerz, &
     upx, upy, upz
 call fglulookat(eyex,eyey,eyez,centerx,centery,centerz,upx,upy,upz)
 return
 end subroutine f9xglulookat
 
 function f9xglunewnurbsrenderer() result(resf9xglunewnurbsrenderer)
 type(glunurbsobj), pointer :: resf9xglunewnurbsrenderer
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glcint) :: nbytes
 integer :: i
 logical :: isnull
 allocate(resf9xglunewnurbsrenderer)
 nbytes = glcptr_length
 call f9yglunewnurbsrenderer(temp,nbytes)
 do i=1,glcptr_length
    resf9xglunewnurbsrenderer%addr(1)%addr(i:i) = char(temp(i))
    resf9xglunewnurbsrenderer%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 isnull = (resf9xglunewnurbsrenderer%addr(1) == glnullptr)
 if (isnull) then
    deallocate(resf9xglunewnurbsrenderer)
    nullify(resf9xglunewnurbsrenderer)
 end if
 return
 end function f9xglunewnurbsrenderer
 
 function f9xglunewquadric() result(resf9xglunewquadric)
 type(gluquadricobj), pointer :: resf9xglunewquadric
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glcint) :: nbytes
 integer :: i
 logical :: isnull
 allocate(resf9xglunewquadric)
 nbytes = glcptr_length
 call f9yglunewquadric(temp,nbytes)
 do i=1,glcptr_length
    resf9xglunewquadric%addr(1)%addr(i:i) = char(temp(i))
    resf9xglunewquadric%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 isnull = (resf9xglunewquadric%addr(1) == glnullptr)
 if (isnull) then
    deallocate(resf9xglunewquadric)
    nullify(resf9xglunewquadric)
 end if
 return
 end function f9xglunewquadric
 
 function f9xglunewtess() result(resf9xglunewtess)
 type(glutesselator), pointer :: resf9xglunewtess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glcint) :: nbytes
 integer :: i,j
 logical :: isnull
 allocate(resf9xglunewtess)
 nbytes = glcptr_length
 call f9yglunewtess(temp,nbytes)
 do i=1,glcptr_length
    resf9xglunewtess%addr(1)%addr(i:i) = char(temp(i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       resf9xglunewtess%addr(j+1)%addr(i:i) = char(temp(i+j*glcptr_length))
    end do
 end do
 isnull = (resf9xglunewtess%addr(1) == glnullptr)
 if (isnull) then
    deallocate(resf9xglunewtess)
    nullify(resf9xglunewtess)
 end if
 return
 end function f9xglunewtess
 
 subroutine f9xglunextcontour(tess,xtype)
 type(glutesselator), pointer :: tess
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglunextcontour(temp,i,xtype)
 return
 end subroutine f9xglunextcontour
 
 
 subroutine f9x1glunurbscallback(nurb,which,callbackfunc)
 integer(kind=glint) ,intent(in) :: callbackfunc
 type(glunurbsobj), pointer :: nurb
 integer(kind=glenum) ,intent(in) :: which
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 if (callbackfunc == glunullfunc) then
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call f9y1glunurbscallback(temp,i,which)
 do i=1,glcptr_length
    nurb%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 end if
 return
 end subroutine f9x1glunurbscallback
 
 subroutine f9xglunurbscallback(nurb,which,callbackfunc)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glenum) ,intent(in) :: which
 interface
     subroutine callbackfunc(errno)
    use opengl_kinds
    integer(kind=glenum) , intent(in out) :: errno
    end subroutine callbackfunc
 end interface
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglunurbscallback(temp,i,which,callbackfunc)
 do i=1,glcptr_length
    nurb%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 return
 end subroutine f9xglunurbscallback
 
 
 subroutine f9xglunurbscurve(nurb,knotcount,knots,stride,control,order,xtype)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glint) ,intent(in) :: knotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: knots
 integer(kind=glint) ,intent(in) :: stride
 real(kind=glfloat), dimension(*), target, intent(in out) :: control
 integer(kind=glint) ,intent(in) :: order
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglunurbscurve(temp,i,knotcount,knots,stride,control,order,xtype)
 return
 end subroutine f9xglunurbscurve
 
 subroutine f9xglunurbsproperty(nurb,property,value)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glenum) ,intent(in) :: property
 real(kind=glfloat) ,intent(in) :: value
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglunurbsproperty(temp,i,property,value)
 return
 end subroutine f9xglunurbsproperty
 
 subroutine f9xglunurbssurface(nurb,sknotcount,sknots,tknotcount,tknots, &
    sstride,tstride,control,sorder,torder,xtype)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glint) ,intent(in) :: sknotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: sknots
 integer(kind=glint) ,intent(in) :: tknotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: tknots
 integer(kind=glint) ,intent(in) :: sstride, tstride
 real(kind=glfloat), dimension(*), target, intent(in out) :: control
 integer(kind=glint) ,intent(in) :: sorder, torder
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglunurbssurface(temp,i,sknotcount,sknots,tknotcount,tknots,sstride, &
    tstride,control,sorder,torder,xtype)
 return
 end subroutine f9xglunurbssurface
 
 subroutine f9xgluortho2d(left,right,bottom,top)
 real(kind=gldouble) ,intent(in) :: left, right, bottom, top
 call fgluortho2d(left,right,bottom,top)
 return
 end subroutine f9xgluortho2d
 
 subroutine f9xglupartialdisk(quad,inner,outer,slices,loops,start,sweep)
 type(gluquadricobj), pointer :: quad
 real(kind=gldouble) ,intent(in) :: inner, outer
 integer(kind=glint) ,intent(in) :: slices, loops
 real(kind=gldouble) ,intent(in) :: start, sweep
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglupartialdisk(temp,i,inner,outer,slices,loops,start,sweep)
 return
 end subroutine f9xglupartialdisk
 
 subroutine f9xgluperspective(fovy,aspect,znear,zfar)
 real(kind=gldouble) ,intent(in) :: fovy, aspect, znear, zfar
 call fgluperspective(fovy,aspect,znear,zfar)
 return
 end subroutine f9xgluperspective
 
 subroutine f9xglupickmatrix(x,y,delx,dely,viewport)
 real(kind=gldouble) ,intent(in) :: x, y, delx, dely
 integer(kind=glint), dimension(*) ,intent(in) :: viewport
 call fglupickmatrix(x,y,delx,dely,viewport)
 return
 end subroutine f9xglupickmatrix
 
 function f9xgluproject(objx,objy,objz,model,proj,view,winx,winy, &
    winz) result(resf9xgluproject)
 real(kind=gldouble) ,intent(in) :: objx, objy, objz
 real(kind=gldouble), dimension(*) ,intent(in) :: model, proj
 integer(kind=glint), dimension(*) ,intent(in) :: view
 real(kind=gldouble), intent(out) :: winx, winy, winz
 integer(kind=glint) :: resf9xgluproject
 resf9xgluproject = fgluproject(objx,objy,objz,model,proj,view,winx,winy,winz)
 return
 end function f9xgluproject
 
 subroutine f9xglupwlcurve(nurb,xcount,data,stride,xtype)
 type(glunurbsobj), pointer :: nurb
 integer(kind=glint) ,intent(in) :: xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: data
 integer(kind=glint) ,intent(in) :: stride
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(nurb%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(nurb%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglupwlcurve(temp,i,xcount,data,stride,xtype)
 return
 end subroutine f9xglupwlcurve
 
 
 subroutine f9x1gluquadriccallback(quad,which,callbackfunc)
 integer(kind=glint) ,intent(in) :: callbackfunc
 type(gluquadricobj), pointer :: quad
 integer(kind=glenum) ,intent(in) :: which
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 if (callbackfunc == glunullfunc) then
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call f9y1gluquadriccallback(temp,i,which)
 do i=1,glcptr_length
    quad%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 end if
 return
 end subroutine f9x1gluquadriccallback
 
 subroutine f9xgluquadriccallback(quad,which,callbackfunc)
 type(gluquadricobj), pointer :: quad
 integer(kind=glenum) ,intent(in) :: which
 interface
     subroutine callbackfunc(errno)
    use opengl_kinds
    integer(kind=glenum) , intent(in out) :: errno
    end subroutine callbackfunc
 end interface
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluquadriccallback(temp,i,which,callbackfunc)
 do i=1,glcptr_length
    quad%addr(2)%addr(i:i) = char(temp(i+glcptr_length))
 end do
 return
 end subroutine f9xgluquadriccallback
 
 
 subroutine f9xgluquadricdrawstyle(quad,draw)
 type(gluquadricobj), pointer :: quad
 integer(kind=glenum) ,intent(in) :: draw
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluquadricdrawstyle(temp,i,draw)
 return
 end subroutine f9xgluquadricdrawstyle
 
 subroutine f9xgluquadricnormals(quad,normal)
 type(gluquadricobj), pointer :: quad
 integer(kind=glenum) ,intent(in) :: normal
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluquadricnormals(temp,i,normal)
 return
 end subroutine f9xgluquadricnormals
 
 subroutine f9xgluquadricorientation(quad,orientation)
 type(gluquadricobj), pointer :: quad
 integer(kind=glenum) ,intent(in) :: orientation
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fgluquadricorientation(temp,i,orientation)
 return
 end subroutine f9xgluquadricorientation
 
 subroutine f9xgluquadrictexture(quad,texture)
 type(gluquadricobj), pointer :: quad
 logical(kind=glboolean) ,intent(in) :: texture
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: int_texture
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 if (glone_byte_logical) then
    call fgluquadrictexture(temp,i,texture)
 else
    if (texture) then
       int_texture = 1
    else
       int_texture = 0
    end if
    call f9egluquadrictexture(temp,i,int_texture)
 end if
 return
 end subroutine f9xgluquadrictexture
 
 function f9x0gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x0gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x0gluscaleimage
 resf9x0gluscaleimage = f9y0gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x0gluscaleimage
 
 function f9x1gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x1gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x1gluscaleimage
 resf9x1gluscaleimage = f9y1gluscaleimage(format,win,hin,typein,datain,wout, &
    hout,typeout,dataout)
 return
 end function f9x1gluscaleimage
 
 function f9x4gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x4gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 type(glcptr) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 type(glcptr) ,intent(in) :: dataout
 integer(kind=glint) :: resf9x4gluscaleimage
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(datain%addr(i:i))
 end do
 do i=1,glcptr_length
    temp(i+glcptr_length) = ichar(dataout%addr(i:i))
 end do
 i = glcptr_length
 resf9x4gluscaleimage = f9y4gluscaleimage(format,win,hin,typein,wout, &
    hout,typeout,temp,i)
 return
 end function f9x4gluscaleimage
 
 function f9x5gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x5gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x5gluscaleimage
 resf9x5gluscaleimage = f9y5gluscaleimage(format,win,hin,typein,datain,wout, &
    hout,typeout,dataout)
 return
 end function f9x5gluscaleimage
 
 function f9x6gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x6gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x6gluscaleimage
 resf9x6gluscaleimage = f9y6gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x6gluscaleimage
 
 function f9x01gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x01gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x01gluscaleimage
 resf9x01gluscaleimage = f9y01gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout)
 return
 end function f9x01gluscaleimage
 
 function f9x04gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x04gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 type(glcptr) ,intent(in) :: dataout
 integer(kind=glint) :: resf9x04gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 i = glcptr_length
 resf9x04gluscaleimage = f9y04gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,temp,i)
 return
 end function f9x04gluscaleimage
 
 function f9x05gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x05gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x05gluscaleimage
 resf9x05gluscaleimage = f9y05gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout)
 return
 end function f9x05gluscaleimage
 
 function f9x06gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x06gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x06gluscaleimage
 resf9x06gluscaleimage = f9y06gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x06gluscaleimage
 
 function f9x10gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x10gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x10gluscaleimage
 resf9x10gluscaleimage = f9y10gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x10gluscaleimage
 
 function f9x14gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x14gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 type(glcptr) ,intent(in) :: dataout
 integer(kind=glint) :: resf9x14gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 i = glcptr_length
 resf9x14gluscaleimage = f9y14gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,temp,i)
 return
 end function f9x14gluscaleimage
 
 function f9x15gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x15gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x15gluscaleimage
 resf9x15gluscaleimage = f9y15gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout)
 return
 end function f9x15gluscaleimage
 
 function f9x16gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x16gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x16gluscaleimage
 resf9x16gluscaleimage = f9y16gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x16gluscaleimage
 
 function f9x40gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x40gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 type(glcptr) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x40gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(datain%addr(i:i))
 end do
 i = glcptr_length
 resf9x40gluscaleimage = f9y40gluscaleimage(format,win,hin,typein,temp,i, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x40gluscaleimage
 
 function f9x41gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x41gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 type(glcptr) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x41gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(datain%addr(i:i))
 end do
 resf9x41gluscaleimage = f9y41gluscaleimage(format,win,hin,typein,temp,i, &
    wout,hout,typeout,dataout)
 return
 end function f9x41gluscaleimage
 
 function f9x45gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x45gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 type(glcptr) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x45gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(datain%addr(i:i))
 end do
 resf9x45gluscaleimage = f9y45gluscaleimage(format,win,hin,typein,temp,i, &
    wout,hout,typeout,dataout)
 return
 end function f9x45gluscaleimage
 
 function f9x46gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x46gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 type(glcptr) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x46gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(datain%addr(i:i))
 end do
 resf9x46gluscaleimage = f9y46gluscaleimage(format,win,hin,typein,temp,i, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x46gluscaleimage
 
 function f9x50gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x50gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x50gluscaleimage
 resf9x50gluscaleimage = f9y50gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x50gluscaleimage
 
 function f9x51gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x51gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x51gluscaleimage
 resf9x51gluscaleimage = f9y51gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout)
 return
 end function f9x51gluscaleimage
 
 function f9x54gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x54gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 type(glcptr) ,intent(in) :: dataout
 integer(kind=glint) :: resf9x54gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 i = glcptr_length
 resf9x54gluscaleimage = f9y54gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,temp,i)
 return
 end function f9x54gluscaleimage
 
 function f9x56gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x56gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x56gluscaleimage
 resf9x56gluscaleimage = f9y56gluscaleimage(format,win,hin,typein,datain, &
    wout,hout,typeout,dataout,size_glint(dataout))
 return
 end function f9x56gluscaleimage
 
 function f9x60gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x60gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 ! need assumed shape to determine size of array
 integer(kind=glint), dimension(:), intent(out) :: dataout
 integer(kind=glint) :: resf9x60gluscaleimage
 resf9x60gluscaleimage = f9y60gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout)
 return
 end function f9x60gluscaleimage
 
 function f9x61gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x61gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x61gluscaleimage
 resf9x61gluscaleimage = f9y61gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout)
 return
 end function f9x61gluscaleimage
 
 function f9x64gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x64gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 type(glcptr) ,intent(in) :: dataout
 integer(kind=glint) :: resf9x64gluscaleimage
 integer(kind=gluint), dimension(glcptr_length) :: temp
 integer(kind=glint) :: i
 i = glcptr_length
 resf9x64gluscaleimage = f9y64gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,temp,i)
 return
 end function f9x64gluscaleimage
 
 function f9x65gluscaleimage(format,win,hin,typein,datain,wout,hout,typeout, &
    dataout) result(resf9x65gluscaleimage)
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 ! need assumed shape to determine size of array
 integer(kind=glshort), dimension(:) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9x65gluscaleimage
 resf9x65gluscaleimage = f9y65gluscaleimage(format,win,hin,typein,datain, &
    size_glint(datain),wout,hout,typeout,dataout)
 return
 end function f9x65gluscaleimage
 
 subroutine f9xglusphere(quad,radius,slices,stacks)
 type(gluquadricobj), pointer :: quad
 real(kind=gldouble) ,intent(in) :: radius
 integer(kind=glint) ,intent(in) :: slices, stacks
 integer(kind=gluint), dimension(2*glcptr_length) :: temp
 integer(kind=glint) :: i
 do i=1,glcptr_length
    temp(i) = ichar(quad%addr(1)%addr(i:i))
    temp(i+glcptr_length) = ichar(quad%addr(2)%addr(i:i))
 end do
 i = glcptr_length
 call fglusphere(temp,i,radius,slices,stacks)
 return
 end subroutine f9xglusphere
 
 subroutine f9xglutessbegincontour(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglutessbegincontour(temp,i)
 return
 end subroutine f9xglutessbegincontour
 
 ! I'm not sure if this will work, but since polygon_data is just passed on
 ! to a callback function, with F we'll try just passing it like with any
 ! other compiler.
 subroutine f9x0glutessbeginpolygon(tess,polygon_data)
 type(glutesselator), pointer :: tess
 integer(kind=glint), dimension(*), target, intent(in out) :: polygon_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y0glutessbeginpolygon(temp,i,polygon_data)
 return
 end subroutine f9x0glutessbeginpolygon
 
 subroutine f9x1glutessbeginpolygon(tess,polygon_data)
 type(glutesselator), pointer :: tess
 real(kind=glfloat), dimension(*), target, intent(in out) :: polygon_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y1glutessbeginpolygon(temp,i,polygon_data)
 return
 end subroutine f9x1glutessbeginpolygon
 
 
 subroutine f9x0glutesscallback(tess,which,callbackfunc)
 type(glutesselator), pointer :: tess
 integer(kind=glenum) ,intent(in) :: which
 external callbackfunc
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y0glutesscallback(temp,i,which,callbackfunc)
 do j=1,num_tess_cb
    do i=1,glcptr_length
       tess%addr(j+1)%addr(i:i) = char(temp(i+j*glcptr_length))
    end do
 end do
 return
 end subroutine f9x0glutesscallback
 
 
 subroutine f9x1glutesscallback(tess,which,callbackfunc)
 integer(kind=glint) ,intent(in) :: callbackfunc
 type(glutesselator), pointer :: tess
 integer(kind=glenum) ,intent(in) :: which
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 if (callbackfunc == glunullfunc) then
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y1glutesscallback(temp,i,which)
 do j=1,num_tess_cb
    do i=1,glcptr_length
       tess%addr(j+1)%addr(i:i) = char(temp(i+j*glcptr_length))
    end do
 end do
 end if
 return
 end subroutine f9x1glutesscallback
 
 
 
 
 subroutine f9xglutessendcontour(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglutessendcontour(temp,i)
 return
 end subroutine f9xglutessendcontour
 
 subroutine f9xglutessendpolygon(tess)
 type(glutesselator), pointer :: tess
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglutessendpolygon(temp,i)
 return
 end subroutine f9xglutessendpolygon
 
 subroutine f9xglutessnormal(tess,valuex,valuey,valuez)
 type(glutesselator), pointer :: tess
 real(kind=gldouble) ,intent(in) :: valuex, valuey, valuez
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglutessnormal(temp,i,valuex,valuey,valuez)
 return
 end subroutine f9xglutessnormal
 
 subroutine f9xglutessproperty(tess,which,data)
 type(glutesselator), pointer :: tess
 integer(kind=glenum) ,intent(in) :: which
 real(kind=gldouble) ,intent(in) :: data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call fglutessproperty(temp,i,which,data)
 return
 end subroutine f9xglutessproperty
 
 ! I'm not sure if this will work, but since vertex_data is just passed on
 ! to a callback function, with F we'll try just passing it like with any
 ! other compiler.
 subroutine f9x0glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glint), dimension(*), target, intent(in out) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y0glutessvertex(temp,i,location,vertex_data)
 return
 end subroutine f9x0glutessvertex
 
 subroutine f9x1glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 real(kind=glfloat), dimension(*), target, intent(in out) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y1glutessvertex(temp,i,location,vertex_data)
 return
 end subroutine f9x1glutessvertex
 
 subroutine f9x4glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 type(glcptr) ,intent(in) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+2)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 do i=1,glcptr_length
    temp(i+(num_tess_cb+1)*glcptr_length) = ichar(vertex_data%addr(i:i))
 end do
 i = glcptr_length
 call f9y4glutessvertex(temp,i,location)
 return
 end subroutine f9x4glutessvertex
 
 subroutine f9x5glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glbyte), dimension(*), target, intent(in out) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y5glutessvertex(temp,i,location,vertex_data)
 return
 end subroutine f9x5glutessvertex
 
 subroutine f9x6glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glshort), dimension(*), target, intent(in out) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y6glutessvertex(temp,i,location,vertex_data)
 return
 end subroutine f9x6glutessvertex
 
 subroutine f9x7glutessvertex(tess,location,vertex_data)
 type(glutesselator), pointer :: tess
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 real(kind=gldouble), dimension(*), target, intent(in out) :: vertex_data
 integer(kind=gluint), dimension((num_tess_cb+1)*glcptr_length) :: temp
 integer(kind=glint) :: i,j
 do i=1,glcptr_length
    temp(i) = ichar(tess%addr(1)%addr(i:i))
 end do
 do j=1,num_tess_cb
    do i=1,glcptr_length
       temp(i+j*glcptr_length) = ichar(tess%addr(j+1)%addr(i:i))
    end do
 end do
 i = glcptr_length
 call f9y7glutessvertex(temp,i,location,vertex_data)
 return
 end subroutine f9x7glutessvertex
 
 function f9xgluunproject(winx,winy,winz,model,proj,view,objx,objy, &
    objz) result(resf9xgluunproject)
 real(kind=gldouble) ,intent(in) :: winx, winy, winz
 real(kind=gldouble), dimension(*) ,intent(in) :: model, proj
 integer(kind=glint), dimension(*) ,intent(in) :: view
 real(kind=gldouble), intent(out) :: objx, objy, objz
 integer(kind=glint) :: resf9xgluunproject
 resf9xgluunproject = fgluunproject(winx,winy,winz,model,proj,view,objx,objy, &
    objz)
 return
 end function f9xgluunproject
 
 end module opengl_glu
