 !----------------------------------------------------------------------------
 !
 !                    f90gl version 1.2.12, September 2006
 !
 !     William F. Mitchell
 !     Mathematical and Computational Sciences Division
 !     National Institute of Standards and Technology
 !     william.mitchell@nist.gov
 !     http://math.nist.gov/f90gl
 !
 ! f90gl is public domain software.  It was produced as part of work done by
 ! the U.S. Government, and is not subject to copyright in the United States.
 !
 !----------------------------------------------------------------------------
 
 
 
 module opengl_gluinterfaces
 use opengl_kinds
 private
 
 ! interface blocks for the C wrappers.
 
 
 
 
 
 
 
 
 !--------------------------
 ! C wrapper procedure names
 !--------------------------
 
 public :: &
    fglubegincurve, &
    fglubeginpolygon, &
    fglubeginsurface, &
    fglubegintrim, &
    f9y0glubuild1dmipmaps, &
    f9y1glubuild1dmipmaps, &
    f9y4glubuild1dmipmaps, &
    f9y5glubuild1dmipmaps, &
    f9y6glubuild1dmipmaps, &
    f9y0glubuild2dmipmaps, &
    f9y1glubuild2dmipmaps, &
    f9y4glubuild2dmipmaps, &
    f9y5glubuild2dmipmaps, &
    f9y6glubuild2dmipmaps, &
    fglucylinder, &
    fgludeletenurbsrenderer, &
    fgludeletequadric, &
    fgludeletetess, &
    fgludisk, &
    fgluendcurve, &
    fgluendpolygon, &
    fgluendsurface, &
    fgluendtrim, &
    f9ygluerrorstringlen, &
    fglugetnurbsproperty, &
    f9yglugetstring, &
    f9yglugetstring1, &
    f9yglugetstringlen, &
    f9yglugetstringfree, &
    fglugettessproperty, &
    fgluloadsamplingmatrices, &
    fglulookat, &
    f9yglunewnurbsrenderer, &
    f9yglunewquadric, &
    f9yglunewtess, &
    fglunextcontour
 public :: &
    fglunurbscallback, &
    f9y1glunurbscallback, &
    fglunurbscurve, &
    fglunurbsproperty, &
    fglunurbssurface, &
    fgluortho2d, &
    fglupartialdisk, &
    fgluperspective, &
    fglupickmatrix, &
    fgluproject, &
    fglupwlcurve, &
    fgluquadriccallback, &
    f9y1gluquadriccallback, &
    fgluquadricdrawstyle, &
    fgluquadricnormals, &
    fgluquadricorientation, &
    fgluquadrictexture, &
    f9egluquadrictexture
 public :: &
    f9y0gluscaleimage, &
    f9y1gluscaleimage, &
    f9y4gluscaleimage, &
    f9y5gluscaleimage, &
    f9y6gluscaleimage, &
    f9y01gluscaleimage, &
    f9y04gluscaleimage, &
    f9y05gluscaleimage, &
    f9y06gluscaleimage, &
    f9y10gluscaleimage, &
    f9y14gluscaleimage, &
    f9y15gluscaleimage, &
    f9y16gluscaleimage, &
    f9y40gluscaleimage, &
    f9y41gluscaleimage, &
    f9y45gluscaleimage, &
    f9y46gluscaleimage, &
    f9y50gluscaleimage, &
    f9y51gluscaleimage, &
    f9y54gluscaleimage, &
    f9y56gluscaleimage, &
    f9y60gluscaleimage, &
    f9y61gluscaleimage, &
    f9y64gluscaleimage, &
    f9y65gluscaleimage, &
    fglusphere, &
    fglutessbegincontour, &
    f9y0glutessbeginpolygon, &
    f9y1glutessbeginpolygon, &
    f9y1glutesscallback
 public :: &
    f9y0glutesscallback, &
    fglutessendcontour, &
    fglutessendpolygon, &
    fglutessnormal, &
    fglutessproperty, &
    f9y0glutessvertex, &
    f9y1glutessvertex, &
    f9y4glutessvertex, &
    f9y5glutessvertex, &
    f9y6glutessvertex, &
    f9y7glutessvertex, &
    fgluunproject
 
 
 interface
 !NAS$ ALIEN "F77 fglubegincurve"
 subroutine fglubegincurve(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglubegincurve
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglubeginpolygon"
 subroutine fglubeginpolygon(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglubeginpolygon
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglubeginsurface"
 subroutine fglubeginsurface(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglubeginsurface
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglubegintrim"
 subroutine fglubegintrim(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglubegintrim
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y0glubuild1dmipmaps"
 function f9y0glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data,length) result(resf9y0glubuild1dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: data
 integer(kind=glint) ,intent(in) :: length
 integer(kind=glint) :: resf9y0glubuild1dmipmaps
 end function f9y0glubuild1dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glubuild1dmipmaps"
 function f9y1glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9y1glubuild1dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9y1glubuild1dmipmaps
 end function f9y1glubuild1dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y4glubuild1dmipmaps"
 function f9y4glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    temp,nbytes) result(resf9y4glubuild1dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y4glubuild1dmipmaps
 end function f9y4glubuild1dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y5glubuild1dmipmaps"
 function f9y5glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data) result(resf9y5glubuild1dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9y5glubuild1dmipmaps
 end function f9y5glubuild1dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y6glubuild1dmipmaps"
 function f9y6glubuild1dmipmaps(xtarget,component,width,format,xtype, &
    data,length) result(resf9y6glubuild1dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: data
 integer(kind=glint) ,intent(in) :: length
 integer(kind=glint) :: resf9y6glubuild1dmipmaps
 end function f9y6glubuild1dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y0glubuild2dmipmaps"
 function f9y0glubuild2dmipmaps(xtarget,component,width,height,format,xtype, &
    data,length) result(resf9y0glubuild2dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width,height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glint), dimension(*) ,intent(in) :: data
 integer(kind=glint) ,intent(in) :: length
 integer(kind=glint) :: resf9y0glubuild2dmipmaps
 end function f9y0glubuild2dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glubuild2dmipmaps"
 function f9y1glubuild2dmipmaps(xtarget,component,width,height,format,xtype, &
    data) result(resf9y1glubuild2dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width,height
 integer(kind=glenum) ,intent(in) :: format, xtype
 real(kind=glfloat), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9y1glubuild2dmipmaps
 end function f9y1glubuild2dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y4glubuild2dmipmaps"
 function f9y4glubuild2dmipmaps(xtarget,component,width,height,format,xtype, &
    temp,nbytes) result(resf9y4glubuild2dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width,height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y4glubuild2dmipmaps
 end function f9y4glubuild2dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y5glubuild2dmipmaps"
 function f9y5glubuild2dmipmaps(xtarget,component,width,height,format,xtype, &
    data) result(resf9y5glubuild2dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width,height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glbyte), dimension(*) ,intent(in) :: data
 integer(kind=glint) :: resf9y5glubuild2dmipmaps
 end function f9y5glubuild2dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y6glubuild2dmipmaps"
 function f9y6glubuild2dmipmaps(xtarget,component,width,height,format,xtype, &
    data,length) result(resf9y6glubuild2dmipmaps)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtarget
 integer(kind=glint) ,intent(in) :: component
 integer(kind=glsizei) ,intent(in) :: width,height
 integer(kind=glenum) ,intent(in) :: format, xtype
 integer(kind=glshort), dimension(*) ,intent(in) :: data
 integer(kind=glint) ,intent(in) :: length
 integer(kind=glint) :: resf9y6glubuild2dmipmaps
 end function f9y6glubuild2dmipmaps
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglucylinder"
 subroutine fglucylinder(quad,nbytes,base,top,height,slices,stacks)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble) ,intent(in) :: base, top, height
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglucylinder
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgludeletenurbsrenderer"
 subroutine fgludeletenurbsrenderer(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgludeletenurbsrenderer
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgludeletequadric"
 subroutine fgludeletequadric(quad,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgludeletequadric
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgludeletetess"
 subroutine fgludeletetess(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgludeletetess
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgludisk"
 subroutine fgludisk(quad,nbytes,inner,outer,slices,loops)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble) ,intent(in) :: inner, outer
 integer(kind=glint) ,intent(in) :: slices, loops
 end subroutine fgludisk
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluendcurve"
 subroutine fgluendcurve(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgluendcurve
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluendpolygon"
 subroutine fgluendpolygon(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgluendpolygon
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluendsurface"
 subroutine fgluendsurface(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgluendsurface
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluendtrim"
 subroutine fgluendtrim(nurb,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fgluendtrim
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9ygluerrorstringlen"
 function f9ygluerrorstringlen(error) result(resf9ygluerrorstringlen)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: error
 integer(kind=glint) :: resf9ygluerrorstringlen
 end function f9ygluerrorstringlen
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglugetnurbsproperty"
 subroutine fglugetnurbsproperty(nurb,nbytes,property,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: property
 real(kind=glfloat), intent(out) :: data
 end subroutine fglugetnurbsproperty
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglugetstringlen"
 function f9yglugetstringlen(error) result(resf9yglugetstringlen)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: error
 integer(kind=glint) :: resf9yglugetstringlen
 end function f9yglugetstringlen
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglugetstring"
 subroutine f9yglugetstring(int_str)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(out) :: int_str
 end subroutine f9yglugetstring
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglugetstring1"
 function f9yglugetstring1(pos) result(resf9yglugetstring1)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: pos
 integer(kind=glint) :: resf9yglugetstring1
 end function f9yglugetstring1
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglugetstringfree"
 subroutine f9yglugetstringfree()
 use opengl_kinds
 implicit none
 end subroutine f9yglugetstringfree
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglugettessproperty"
 subroutine fglugettessproperty(tess,nbytes,which,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 real(kind=gldouble), intent(out) :: data
 end subroutine fglugettessproperty
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluloadsamplingmatrices"
 subroutine fgluloadsamplingmatrices(nurb,nbytes,model,perspective, &
    view)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=glfloat), dimension(*) ,intent(in) :: model, perspective
 integer(kind=glint), dimension(*) ,intent(in) :: view
 end subroutine fgluloadsamplingmatrices
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglulookat"
 subroutine fglulookat(eyex,eyey,eyez,centerx,centery,centerz, &
    upx,upy,upz)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: eyex, eyey, eyez, centerx, centery, centerz, &
     upx, upy, upz
 end subroutine fglulookat
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglunewnurbsrenderer"
 subroutine f9yglunewnurbsrenderer(temp,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(out) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine f9yglunewnurbsrenderer
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglunewquadric"
 subroutine f9yglunewquadric(temp,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(out) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine f9yglunewquadric
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglunewtess"
 subroutine f9yglunewtess(temp,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(out) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine f9yglunewtess
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglunextcontour"
 subroutine fglunextcontour(tess,nbytes,xtype)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: xtype
 end subroutine fglunextcontour
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glunurbscallback"
 subroutine f9y1glunurbscallback(nurb,nbytes,which)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(in out) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 end subroutine f9y1glunurbscallback
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglunurbscurve"
 subroutine fglunurbscurve(nurb,nbytes,knotcount,knots,stride,control, &
    order,xtype)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) ,intent(in) :: knotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: knots
 integer(kind=glint) ,intent(in) :: stride
 real(kind=glfloat), dimension(*), target, intent(in out) :: control
 integer(kind=glint) ,intent(in) :: order
 integer(kind=glenum) ,intent(in) :: xtype
 end subroutine fglunurbscurve
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglunurbsproperty"
 subroutine fglunurbsproperty(nurb,nbytes,property,value)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: property
 real(kind=glfloat) ,intent(in) :: value
 end subroutine fglunurbsproperty
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglunurbssurface"
 subroutine fglunurbssurface(nurb,nbytes,sknotcount,sknots,tknotcount, &
    tknots,sstride,tstride,control,sorder,torder,xtype)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) ,intent(in) :: sknotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: sknots
 integer(kind=glint) ,intent(in) :: tknotcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: tknots
 integer(kind=glint) ,intent(in) :: sstride, tstride
 real(kind=glfloat), dimension(*), target, intent(in out) :: control
 integer(kind=glint) ,intent(in) :: sorder, torder
 integer(kind=glenum) ,intent(in) :: xtype
 end subroutine fglunurbssurface
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluortho2d"
 subroutine fgluortho2d(left,right,bottom,top)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: left, right, bottom, top
 end subroutine fgluortho2d
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglupartialdisk"
 subroutine fglupartialdisk(quad,nbytes,inner,outer,slices,loops,start, &
    sweep)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble) ,intent(in) :: inner, outer
 integer(kind=glint) ,intent(in) :: slices, loops
 real(kind=gldouble) ,intent(in) :: start, sweep
 end subroutine fglupartialdisk
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluperspective"
 subroutine fgluperspective(fovy,aspect,znear,zfar)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: fovy, aspect, znear, zfar
 end subroutine fgluperspective
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglupickmatrix"
 subroutine fglupickmatrix(x,y,delx,dely,viewport)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: x, y, delx, dely
 integer(kind=glint), dimension(*) ,intent(in) :: viewport
 end subroutine fglupickmatrix
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluproject"
 function fgluproject(objx,objy,objz,model,proj,view,winx,winy, &
    winz) result(resfgluproject)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: objx, objy, objz
 real(kind=gldouble), dimension(*) ,intent(in) :: model, proj
 integer(kind=glint), dimension(*) ,intent(in) :: view
 real(kind=gldouble), intent(out) :: winx, winy, winz
 integer(kind=glint) :: resfgluproject
 end function fgluproject
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglupwlcurve"
 subroutine fglupwlcurve(nurb,nbytes,xcount,data,stride,xtype)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: nurb
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) ,intent(in) :: xcount
 real(kind=glfloat), dimension(*), target, intent(in out) :: data
 integer(kind=glint) ,intent(in) :: stride
 integer(kind=glenum) ,intent(in) :: xtype
 end subroutine fglupwlcurve
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1gluquadriccallback"
 subroutine f9y1gluquadriccallback(quad,nbytes,which)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*), intent(in out) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 end subroutine f9y1gluquadriccallback
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluquadricdrawstyle"
 subroutine fgluquadricdrawstyle(quad,nbytes,draw)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: draw
 end subroutine fgluquadricdrawstyle
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluquadricnormals"
 subroutine fgluquadricnormals(quad,nbytes,normal)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: normal
 end subroutine fgluquadricnormals
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluquadricorientation"
 subroutine fgluquadricorientation(quad,nbytes,orientation)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: orientation
 end subroutine fgluquadricorientation
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluquadrictexture"
 subroutine fgluquadrictexture(quad,nbytes,texture)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 logical(kind=glboolean) ,intent(in) :: texture
 end subroutine fgluquadrictexture
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9egluquadrictexture"
 subroutine f9egluquadrictexture(quad,nbytes,texture)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) ,intent(in) :: texture
 end subroutine f9egluquadrictexture
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y0gluscaleimage"
 function f9y0gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout,lengthout) result(resf9y0gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glint), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y0gluscaleimage
 end function f9y0gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1gluscaleimage"
 function f9y1gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout) result(resf9y1gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y1gluscaleimage
 end function f9y1gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y4gluscaleimage"
 function f9y4gluscaleimage(format,win,hin,typein,wout,hout, &
    typeout,temp,nbytes) result(resf9y4gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y4gluscaleimage
 end function f9y4gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y5gluscaleimage"
 function f9y5gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout) result(resf9y5gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y5gluscaleimage
 end function f9y5gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y6gluscaleimage"
 function f9y6gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout,lengthout) result(resf9y6gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glshort), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glshort), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y6gluscaleimage
 end function f9y6gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y01gluscaleimage"
 function f9y01gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y01gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y01gluscaleimage
 end function f9y01gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y04gluscaleimage"
 function f9y04gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,temp,nbytes) result(resf9y04gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y04gluscaleimage
 end function f9y04gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y05gluscaleimage"
 function f9y05gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y05gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y05gluscaleimage
 end function f9y05gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y06gluscaleimage"
 function f9y06gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout,lengthout) result(resf9y06gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glshort), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y06gluscaleimage
 end function f9y06gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y10gluscaleimage"
 function f9y10gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout,lengthout) result(resf9y10gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glint), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y10gluscaleimage
 end function f9y10gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y14gluscaleimage"
 function f9y14gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,temp,nbytes) result(resf9y14gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y14gluscaleimage
 end function f9y14gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y15gluscaleimage"
 function f9y15gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout) result(resf9y15gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y15gluscaleimage
 end function f9y15gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y16gluscaleimage"
 function f9y16gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout,lengthout) result(resf9y16gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 real(kind=glfloat), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glshort), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y16gluscaleimage
 end function f9y16gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y40gluscaleimage"
 function f9y40gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout,lengthout) result(resf9y40gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=gluint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glint), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y40gluscaleimage
 end function f9y40gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y41gluscaleimage"
 function f9y41gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y41gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=gluint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y41gluscaleimage
 end function f9y41gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y45gluscaleimage"
 function f9y45gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y45gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=gluint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y45gluscaleimage
 end function f9y45gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y46gluscaleimage"
 function f9y46gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout,lengthout) result(resf9y46gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=gluint), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glshort), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y46gluscaleimage
 end function f9y46gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y50gluscaleimage"
 function f9y50gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout,lengthout) result(resf9y50gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glint), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y50gluscaleimage
 end function f9y50gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y51gluscaleimage"
 function f9y51gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout) result(resf9y51gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y51gluscaleimage
 end function f9y51gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y54gluscaleimage"
 function f9y54gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,temp,nbytes) result(resf9y54gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y54gluscaleimage
 end function f9y54gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y56gluscaleimage"
 function f9y56gluscaleimage(format,win,hin,typein,datain,wout,hout, &
    typeout,dataout,lengthout) result(resf9y56gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glbyte), dimension(*) ,intent(in) :: datain
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glshort), dimension(*), intent(out) :: dataout
 integer(kind=glint) ,intent(in) :: lengthout
 integer(kind=glint) :: resf9y56gluscaleimage
 end function f9y56gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y60gluscaleimage"
 function f9y60gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y60gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glshort), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glint), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y60gluscaleimage
 end function f9y60gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y61gluscaleimage"
 function f9y61gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y61gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glshort), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 real(kind=glfloat), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y61gluscaleimage
 end function f9y61gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y64gluscaleimage"
 function f9y64gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,temp,nbytes) result(resf9y64gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glshort), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=gluint), dimension(*) ,intent(in) :: temp
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint) :: resf9y64gluscaleimage
 end function f9y64gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y65gluscaleimage"
 function f9y65gluscaleimage(format,win,hin,typein,datain,lengthin,wout,hout, &
    typeout,dataout) result(resf9y65gluscaleimage)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: format
 integer(kind=glsizei) ,intent(in) :: win, hin
 integer(kind=glenum) ,intent(in) :: typein
 integer(kind=glshort), dimension(*) ,intent(in) :: datain
 integer(kind=glint) ,intent(in) :: lengthin
 integer(kind=glsizei) ,intent(in) :: wout, hout
 integer(kind=glenum) ,intent(in) :: typeout
 integer(kind=glbyte), dimension(*), intent(out) :: dataout
 integer(kind=glint) :: resf9y65gluscaleimage
 end function f9y65gluscaleimage
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglusphere"
 subroutine fglusphere(quad,nbytes,radius,slices,stacks)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: quad
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble) ,intent(in) :: radius
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglusphere
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutessbegincontour"
 subroutine fglutessbegincontour(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglutessbegincontour
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y0glutessbeginpolygon"
 subroutine f9y0glutessbeginpolygon(tess,nbytes,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glint), dimension(*), target, intent(in out) :: data
 end subroutine f9y0glutessbeginpolygon
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutessbeginpolygon"
 subroutine f9y1glutessbeginpolygon(tess,nbytes,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=glfloat), dimension(*), target, intent(in out) :: data
 end subroutine f9y1glutessbeginpolygon
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutesscallback"
 subroutine f9y1glutesscallback(tess,nbytes,which)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*), intent(in out) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 end subroutine f9y1glutesscallback
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutessendcontour"
 subroutine fglutessendcontour(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglutessendcontour
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutessendpolygon"
 subroutine fglutessendpolygon(tess,nbytes)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 end subroutine fglutessendpolygon
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutessnormal"
 subroutine fglutessnormal(tess,nbytes,valuex,valuey,valuez)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble) ,intent(in) :: valuex, valuey, valuez
 end subroutine fglutessnormal
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutessproperty"
 subroutine fglutessproperty(tess,nbytes,which,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 real(kind=gldouble) ,intent(in) :: data
 end subroutine fglutessproperty
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y0glutessvertex"
 subroutine f9y0glutessvertex(tess,nbytes,location,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glint), dimension(*), target, intent(in out) :: data
 end subroutine f9y0glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutessvertex"
 subroutine f9y1glutessvertex(tess,nbytes,location,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 real(kind=glfloat), dimension(*), target, intent(in out) :: data
 end subroutine f9y1glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y4glutessvertex"
 subroutine f9y4glutessvertex(tess,nbytes,location)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 end subroutine f9y4glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y5glutessvertex"
 subroutine f9y5glutessvertex(tess,nbytes,location,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glbyte), dimension(*), target, intent(in out) :: data
 end subroutine f9y5glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y6glutessvertex"
 subroutine f9y6glutessvertex(tess,nbytes,location,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 integer(kind=glshort), dimension(*), target, intent(in out) :: data
 end subroutine f9y6glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y7glutessvertex"
 subroutine f9y7glutessvertex(tess,nbytes,location,data)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 real(kind=gldouble), dimension(*) ,intent(in) :: location
 real(kind=gldouble), dimension(*), target, intent(in out) :: data
 end subroutine f9y7glutessvertex
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluunproject"
 function fgluunproject(winx,winy,winz,model,proj,view,objx, &
    objy,objz) result(resfgluunproject)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: winx, winy, winz
 real(kind=gldouble), dimension(*) ,intent(in) :: model, proj
 integer(kind=glint), dimension(*) ,intent(in) :: view
 real(kind=gldouble), intent(out) :: objx, objy, objz
 integer(kind=glint) :: resfgluunproject
 end function fgluunproject
 end interface
 
 
 interface
 subroutine fglunurbscallback(nurb,nbytes,which,callbackfunc)
 use opengl_kinds
 implicit none
 integer(kind=gluint), dimension(*), intent(in out) :: nurb
 integer(kind=glint)  ,intent(in) :: nbytes
 integer(kind=glenum)  ,intent(in) :: which
 interface
     subroutine callbackfunc(errno)
    use opengl_kinds
    implicit none
    integer(kind=glenum) , intent(in out) :: errno
    end subroutine callbackfunc
 end interface
 end subroutine fglunurbscallback
 end interface
 
 interface
 subroutine fgluquadriccallback(quad,nbytes,which,callbackfunc)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*), intent(in out) :: quad
 integer(kind=glint)  ,intent(in) :: nbytes
 integer(kind=glenum)  ,intent(in) :: which
 interface
     subroutine callbackfunc(errno)
    use opengl_kinds
    implicit none
    integer(kind=glenum) , intent(in out) :: errno
    end subroutine callbackfunc
 end interface
 end subroutine fgluquadriccallback
 end interface
 
 
 interface
 subroutine f9y0glutesscallback(tess,nbytes,which,callbackfunc)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*), intent(in out) :: tess
 integer(kind=glint) ,intent(in) :: nbytes
 integer(kind=glenum) ,intent(in) :: which
 external callbackfunc
 end subroutine f9y0glutesscallback
 end interface
 
 
 
 end module opengl_gluinterfaces
