 !----------------------------------------------------------------------------
 !
 !                    f90gl version 1.2.12, September 2006
 !
 !     William F. Mitchell
 !     Mathematical and Computational Sciences Division
 !     National Institute of Standards and Technology
 !     william.mitchell@nist.gov
 !     http://math.nist.gov/f90gl
 !
 ! f90gl is public domain software.  It was produced as part of work done by
 ! the U.S. Government, and is not subject to copyright in the United States.
 !
 !----------------------------------------------------------------------------
 
 
 
 ! include support for new routines in GLUT 3.7
 
 module opengl_glutinterfaces
 use opengl_kinds
 private
 
 ! interface blocks for the C wrappers.
 
 
 
 
 
 !--------------------------
 ! C wrapper procedure names
 !--------------------------
 
 public :: &
    f9yglutaddmenuentry, &
    f9yglutaddsubmenu, &
    fglutattachmenu, &
    fglutbitmapcharacter, &
    fglutbitmaplength, &
    fglutbitmapwidth, &
    fglutbuttonboxfunc, &
    f9y1glutbuttonboxfunc, &
    f9yglutchangetomenuentry, &
    f9yglutchangetosubmenu, &
    fglutcopycolormap, &
    fglutcreatemenu, &
    fglutcreatesubwindow, &
    f9yglutcreatewindow, &
    fglutdestroymenu, &
    fglutdestroywindow, &
    fglutdetachmenu, &
    fglutdeviceget, &
    fglutdialsfunc, &
    f9y1glutdialsfunc, &
    fglutdisplayfunc, &
    fglutentryfunc, &
    f9y1glutentryfunc, &
    fglutestablishoverlay, &
    f9yglutextensionsupported, &
    fglutfullscreen, &
    fglutget, &
    fglutgetcolor, &
    fglutgetmenu, &
    fglutgetmodifiers, &
    fglutgetwindow, &
    fgluthideoverlay, &
    fgluthidewindow, &
    fgluticonifywindow
 public :: &
    fglutidlefunc, &
    f9y1glutidlefunc, &
    fglutinit, &
    fglutinitargs, &
    fglutinitdisplaymode, &
    f9yglutinitdisplaystring, &
    fglutinitwindowposition, &
    fglutinitwindowsize, &
    fglutkeyboardfunc, &
    f9y1glutkeyboardfunc, &
    fglutlayerget, &
    fglutmainloop, &
    fglutmenustatefunc, &
    f9y1glutmenustatefunc, &
    fglutmenustatusfunc, &
    f9y1glutmenustatusfunc, &
    fglutmotionfunc, &
    f9y1glutmotionfunc, &
    fglutmousefunc, &
    f9y1glutmousefunc, &
    fglutoverlaydisplayfunc, &
    f9y1glutoverlaydisplayfunc, &
    fglutpassivemotionfunc, &
    f9y1glutpassivemotionfunc, &
    fglutpopwindow, &
    fglutpositionwindow, &
    fglutpostoverlayredisplay, &
    fglutpostredisplay, &
    fglutpostwindowoverlayredisplay, &
    fglutpostwindowredisplay, &
    fglutpushwindow, &
    fglutremovemenuitem, &
    fglutremoveoverlay, &
    fglutreporterrors, &
    fglutreshapefunc, &
    f9y1glutreshapefunc
 public :: &
    fglutreshapewindow, &
    fglutsetcolor, &
    fglutsetcursor, &
    f9yglutseticontitle, &
    fglutsetmenu, &
    fglutsetwindow, &
    f9yglutsetwindowtitle, &
    fglutsetupvideoresizing, &
    fglutshowoverlay, &
    fglutshowwindow, &
    fglutsolidcone, &
    fglutsolidcube, &
    fglutsoliddodecahedron, &
    fglutsolidicosahedron, &
    fglutsolidoctahedron, &
    fglutsolidsphere, &
    fglutsolidteapot, &
    fglutsolidtetrahedron, &
    fglutsolidtorus, &
    fglutspaceballbuttonfunc, &
    f9y1glutspaceballbuttonfunc, &
    fglutspaceballmotionfunc, &
    f9y1glutspaceballmotionfunc, &
    fglutspaceballrotatefunc, &
    f9y1glutspaceballrotatefunc, &
    fglutspecialfunc, &
    f9y1glutspecialfunc, &
    fglutstopvideoresizing, &
    fglutstrokecharacter, &
    fglutstrokelength, &
    fglutstrokewidth, &
    fglutswapbuffers, &
    fgluttabletbuttonfunc, &
    f9y1gluttabletbuttonfunc, &
    fgluttabletmotionfunc
 public :: &
    f9y1gluttabletmotionfunc, &
    fgluttimerfunc, &
    fglutuselayer, &
    fglutvideopan, &
    fglutvideoresize, &
    fglutvideoresizeget, &
    fglutvisibilityfunc, &
    f9y1glutvisibilityfunc, &
    fglutwarppointer, &
    fglutwindowstatusfunc, &
    f9y1glutwindowstatusfunc, &
    fglutwirecone, &
    fglutwirecube, &
    fglutwiredodecahedron, &
    fglutwireicosahedron, &
    fglutwireoctahedron, &
    fglutwiresphere, &
    fglutwireteapot, &
    fglutwiretetrahedron, &
    fglutwiretorus
 public :: &
    fglutkeyboardupfunc, &
    f9y1glutkeyboardupfunc, &
    fglutspecialupfunc, &
    f9y1glutspecialupfunc, &
    fglutjoystickfunc, &
    f9y1glutjoystickfunc, &
    fglutignorekeyrepeat, &
    fglutsetkeyrepeat, &
    fglutforcejoystickfunc, &
    f9yglutgamemodestring, &
    fglutentergamemode, &
    fglutleavegamemode, &
    fglutgamemodeget
 
 interface
 !NAS$ ALIEN "F77 f9yglutaddmenuentry"
 subroutine f9yglutaddmenuentry(label,size_label,value)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: label
 integer(kind=glint) ,intent(in) :: size_label
 integer(kind=glcint) ,intent(in) :: value
 end subroutine f9yglutaddmenuentry
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutaddsubmenu"
 subroutine f9yglutaddsubmenu(label,size_label,submenu)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: label
 integer(kind=glint) ,intent(in) :: size_label
 integer(kind=glcint) ,intent(in) :: submenu
 end subroutine f9yglutaddsubmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutattachmenu"
 subroutine fglutattachmenu(button)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: button
 end subroutine fglutattachmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutbitmapcharacter"
 subroutine fglutbitmapcharacter(font,xcharacter)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glcint) ,intent(in) :: xcharacter
 end subroutine fglutbitmapcharacter
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutbitmaplength"
 function fglutbitmaplength(font,string,size_string) result(resfglutbitmaplength)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glint), dimension(*) ,intent(in) :: string
 integer(kind=glint) ,intent(in) :: size_string
 integer(kind=glcint) :: resfglutbitmaplength
 end function fglutbitmaplength
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutbitmapwidth"
 function fglutbitmapwidth(font,xcharacter) result(resfglutbitmapwidth)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glcint) ,intent(in) :: xcharacter
 integer(kind=glcint) :: resfglutbitmapwidth
 end function fglutbitmapwidth
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutbuttonboxfunc"
 subroutine f9y1glutbuttonboxfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutbuttonboxfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutchangetomenuentry"
 subroutine f9yglutchangetomenuentry(item,label,size_label,value)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: item
 integer(kind=glint), dimension(*) ,intent(in) :: label
 integer(kind=glint) ,intent(in) :: size_label
 integer(kind=glcint) ,intent(in) :: value
 end subroutine f9yglutchangetomenuentry
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutchangetosubmenu"
 subroutine f9yglutchangetosubmenu(item,label,size_label,submenu)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: item
 integer(kind=glint), dimension(*) ,intent(in) :: label
 integer(kind=glint) ,intent(in) :: size_label
 integer(kind=glcint) ,intent(in) :: submenu
 end subroutine f9yglutchangetosubmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutcopycolormap"
 subroutine fglutcopycolormap(win)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win
 end subroutine fglutcopycolormap
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutcreatesubwindow"
 function fglutcreatesubwindow(win,x,y,width, &
    height) result(resfglutcreatesubwindow)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win, x, y, width, height
 integer(kind=glcint) :: resfglutcreatesubwindow
 end function fglutcreatesubwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutcreatewindow"
 function f9yglutcreatewindow(title,size_title) result(resf9yglutcreatewindow)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: title
 integer(kind=glint) ,intent(in) :: size_title
 integer(kind=glcint) :: resf9yglutcreatewindow
 end function f9yglutcreatewindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutdestroymenu"
 subroutine fglutdestroymenu(menu)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: menu
 end subroutine fglutdestroymenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutdestroywindow"
 subroutine fglutdestroywindow(win)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win
 end subroutine fglutdestroywindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutdetachmenu"
 subroutine fglutdetachmenu(button)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: button
 end subroutine fglutdetachmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutdeviceget"
 function fglutdeviceget(xtype) result(resfglutdeviceget)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glcint) :: resfglutdeviceget
 end function fglutdeviceget
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutdialsfunc"
 subroutine f9y1glutdialsfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutdialsfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutentryfunc"
 subroutine f9y1glutentryfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutentryfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutestablishoverlay"
 subroutine fglutestablishoverlay()
 use opengl_kinds
 implicit none
 end subroutine fglutestablishoverlay
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutextensionsupported"
 function f9yglutextensionsupported(name,size_name) &
    result(resf9yglutextensionsupported)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: name
 integer(kind=glint) ,intent(in) :: size_name
 integer(kind=glcint) :: resf9yglutextensionsupported
 end function f9yglutextensionsupported
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutfullscreen"
 subroutine fglutfullscreen()
 use opengl_kinds
 implicit none
 end subroutine fglutfullscreen
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutget"
 function fglutget(xtype) result(resfglutget)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glcint) :: resfglutget
 end function fglutget
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutgetcolor"
 function fglutgetcolor(ndx,component) result(resfglutgetcolor)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: ndx, component
 real(kind=glfloat) :: resfglutgetcolor
 end function fglutgetcolor
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutgetmenu"
 function fglutgetmenu() result(resfglutgetmenu)
 use opengl_kinds
 implicit none
 integer(kind=glcint) :: resfglutgetmenu
 end function fglutgetmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutgetmodifiers"
 function fglutgetmodifiers() result(resfglutgetmodifiers)
 use opengl_kinds
 implicit none
 integer(kind=glcint) :: resfglutgetmodifiers
 end function fglutgetmodifiers
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutgetwindow"
 function fglutgetwindow() result(resfglutgetwindow)
 use opengl_kinds
 implicit none
 integer(kind=glcint) :: resfglutgetwindow
 end function fglutgetwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluthideoverlay"
 subroutine fgluthideoverlay()
 use opengl_kinds
 implicit none
 end subroutine fgluthideoverlay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluthidewindow"
 subroutine fgluthidewindow()
 use opengl_kinds
 implicit none
 end subroutine fgluthidewindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fgluticonifywindow"
 subroutine fgluticonifywindow()
 use opengl_kinds
 implicit none
 end subroutine fgluticonifywindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutidlefunc"
 subroutine f9y1glutidlefunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutidlefunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutinit"
 subroutine fglutinit()
 use opengl_kinds
 implicit none
 end subroutine fglutinit
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutinitargs"
 subroutine fglutinitargs(argcp,argv,starts)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: argcp
 integer(kind=glint), dimension(*) ,intent(in) :: argv, starts
 end subroutine fglutinitargs
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutinitdisplaymode"
 subroutine fglutinitdisplaymode(mode)
 use opengl_kinds
 implicit none
 integer(kind=glcuint) ,intent(in) :: mode
 end subroutine fglutinitdisplaymode
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutinitdisplaystring"
 subroutine f9yglutinitdisplaystring(string,size_string)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: string
 integer(kind=glint) ,intent(in) :: size_string
 end subroutine f9yglutinitdisplaystring
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutinitwindowposition"
 subroutine fglutinitwindowposition(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: x, y
 end subroutine fglutinitwindowposition
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutinitwindowsize"
 subroutine fglutinitwindowsize(width,height)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: width, height
 end subroutine fglutinitwindowsize
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutkeyboardfunc"
 subroutine f9y1glutkeyboardfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutkeyboardfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutlayerget"
 function fglutlayerget(xtype) result(resfglutlayerget)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: xtype
 integer(kind=glcint) :: resfglutlayerget
 end function fglutlayerget
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutmainloop"
 subroutine fglutmainloop()
 use opengl_kinds
 implicit none
 end subroutine fglutmainloop
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutmenustatefunc"
 subroutine f9y1glutmenustatefunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutmenustatefunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutmenustatusfunc"
 subroutine f9y1glutmenustatusfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutmenustatusfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutmotionfunc"
 subroutine f9y1glutmotionfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutmotionfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutmousefunc"
 subroutine f9y1glutmousefunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutmousefunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutoverlaydisplayfunc"
 subroutine f9y1glutoverlaydisplayfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutoverlaydisplayfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutpassivemotionfunc"
 subroutine f9y1glutpassivemotionfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutpassivemotionfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpopwindow"
 subroutine fglutpopwindow()
 use opengl_kinds
 implicit none
 end subroutine fglutpopwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpositionwindow"
 subroutine fglutpositionwindow(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: x, y
 end subroutine fglutpositionwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpostoverlayredisplay"
 subroutine fglutpostoverlayredisplay()
 use opengl_kinds
 implicit none
 end subroutine fglutpostoverlayredisplay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpostredisplay"
 subroutine fglutpostredisplay()
 use opengl_kinds
 implicit none
 end subroutine fglutpostredisplay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpostwindowoverlayredisplay"
 subroutine fglutpostwindowoverlayredisplay(win)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win
 end subroutine fglutpostwindowoverlayredisplay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpostwindowredisplay"
 subroutine fglutpostwindowredisplay(win)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win
 end subroutine fglutpostwindowredisplay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutpushwindow"
 subroutine fglutpushwindow()
 use opengl_kinds
 implicit none
 end subroutine fglutpushwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutremovemenuitem"
 subroutine fglutremovemenuitem(item)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: item
 end subroutine fglutremovemenuitem
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutremoveoverlay"
 subroutine fglutremoveoverlay()
 use opengl_kinds
 implicit none
 end subroutine fglutremoveoverlay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutreporterrors"
 subroutine fglutreporterrors()
 use opengl_kinds
 implicit none
 end subroutine fglutreporterrors
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutreshapefunc"
 subroutine f9y1glutreshapefunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutreshapefunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutreshapewindow"
 subroutine fglutreshapewindow(width,height)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: width, height
 end subroutine fglutreshapewindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetcolor"
 subroutine fglutsetcolor(cell,red,green,blue)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: cell
 real(kind=glfloat) ,intent(in) :: red, green, blue
 end subroutine fglutsetcolor
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetcursor"
 subroutine fglutsetcursor(cursor)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: cursor
 end subroutine fglutsetcursor
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutseticontitle"
 subroutine f9yglutseticontitle(title,size_title)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: title
 integer(kind=glint) ,intent(in) :: size_title
 end subroutine f9yglutseticontitle
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetmenu"
 subroutine fglutsetmenu(menu)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: menu
 end subroutine fglutsetmenu
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetwindow"
 subroutine fglutsetwindow(win)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: win
 end subroutine fglutsetwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutsetwindowtitle"
 subroutine f9yglutsetwindowtitle(title,size_title)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: title
 integer(kind=glint) ,intent(in) :: size_title
 end subroutine f9yglutsetwindowtitle
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetupvideoresizing"
 subroutine fglutsetupvideoresizing()
 use opengl_kinds
 implicit none
 end subroutine fglutsetupvideoresizing
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutshowoverlay"
 subroutine fglutshowoverlay()
 use opengl_kinds
 implicit none
 end subroutine fglutshowoverlay
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutshowwindow"
 subroutine fglutshowwindow()
 use opengl_kinds
 implicit none
 end subroutine fglutshowwindow
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidcone"
 subroutine fglutsolidcone(base,height,slices,stacks)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: base, height
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglutsolidcone
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidcube"
 subroutine fglutsolidcube(xsize)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: xsize
 end subroutine fglutsolidcube
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsoliddodecahedron"
 subroutine fglutsoliddodecahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutsoliddodecahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidicosahedron"
 subroutine fglutsolidicosahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutsolidicosahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidoctahedron"
 subroutine fglutsolidoctahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutsolidoctahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidsphere"
 subroutine fglutsolidsphere(radius,slices,stacks)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: radius
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglutsolidsphere
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidteapot"
 subroutine fglutsolidteapot(xsize)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: xsize
 end subroutine fglutsolidteapot
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidtetrahedron"
 subroutine fglutsolidtetrahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutsolidtetrahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsolidtorus"
 subroutine fglutsolidtorus(innerradius,outerradius,sides, &
    rings)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: innerradius, outerradius
 integer(kind=glint) ,intent(in) :: sides, rings
 end subroutine fglutsolidtorus
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutspaceballbuttonfunc"
 subroutine f9y1glutspaceballbuttonfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutspaceballbuttonfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutspaceballmotionfunc"
 subroutine f9y1glutspaceballmotionfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutspaceballmotionfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutspaceballrotatefunc"
 subroutine f9y1glutspaceballrotatefunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutspaceballrotatefunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutspecialfunc"
 subroutine f9y1glutspecialfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutspecialfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutstopvideoresizing"
 subroutine fglutstopvideoresizing()
 use opengl_kinds
 implicit none
 end subroutine fglutstopvideoresizing
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutstrokecharacter"
 subroutine fglutstrokecharacter(font,xcharacter)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glcint) ,intent(in) :: xcharacter
 end subroutine fglutstrokecharacter
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutstrokelength"
 function fglutstrokelength(font,string,size_string) result(resfglutstrokelength)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glint), dimension(*) ,intent(in) :: string
 integer(kind=glint) ,intent(in) :: size_string
 integer(kind=glcint) :: resfglutstrokelength
 end function fglutstrokelength
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutstrokewidth"
 function fglutstrokewidth(font,xcharacter) result(resfglutstrokewidth)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: font
 integer(kind=glcint) ,intent(in) :: xcharacter
 integer(kind=glcint) :: resfglutstrokewidth
 end function fglutstrokewidth
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutswapbuffers"
 subroutine fglutswapbuffers()
 use opengl_kinds
 implicit none
 end subroutine fglutswapbuffers
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1gluttabletbuttonfunc"
 subroutine f9y1gluttabletbuttonfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1gluttabletbuttonfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1gluttabletmotionfunc"
 subroutine f9y1gluttabletmotionfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1gluttabletmotionfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutuselayer"
 subroutine fglutuselayer(layer)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: layer
 end subroutine fglutuselayer
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutvideopan"
 subroutine fglutvideopan(x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: x, y, width, height
 end subroutine fglutvideopan
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutvideoresize"
 subroutine fglutvideoresize(x,y,width,height)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: x, y, width, height
 end subroutine fglutvideoresize
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutvideoresizeget"
 function fglutvideoresizeget(param) result(resfglutvideoresizeget)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: param
 integer(kind=glcint) :: resfglutvideoresizeget
 end function fglutvideoresizeget
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutvisibilityfunc"
 subroutine f9y1glutvisibilityfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutvisibilityfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwarppointer"
 subroutine fglutwarppointer(x,y)
 use opengl_kinds
 implicit none
 integer(kind=glcint) ,intent(in) :: x, y
 end subroutine fglutwarppointer
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutwindowstatusfunc"
 subroutine f9y1glutwindowstatusfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutwindowstatusfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwirecone"
 subroutine fglutwirecone(base,height,slices,stacks)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: base, height
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglutwirecone
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwirecube"
 subroutine fglutwirecube(xsize)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: xsize
 end subroutine fglutwirecube
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwiredodecahedron"
 subroutine fglutwiredodecahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutwiredodecahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwireicosahedron"
 subroutine fglutwireicosahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutwireicosahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwireoctahedron"
 subroutine fglutwireoctahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutwireoctahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwiresphere"
 subroutine fglutwiresphere(radius,slices,stacks)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: radius
 integer(kind=glint) ,intent(in) :: slices, stacks
 end subroutine fglutwiresphere
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwireteapot"
 subroutine fglutwireteapot(xsize)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: xsize
 end subroutine fglutwireteapot
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwiretetrahedron"
 subroutine fglutwiretetrahedron()
 use opengl_kinds
 implicit none
 end subroutine fglutwiretetrahedron
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutwiretorus"
 subroutine fglutwiretorus(innerradius,outerradius,sides,rings)
 use opengl_kinds
 implicit none
 real(kind=gldouble) ,intent(in) :: innerradius, outerradius
 integer(kind=glint) ,intent(in) :: sides, rings
 end subroutine fglutwiretorus
 end interface
 
 
 interface
 !NAS$ ALIEN "F77 f9y1glutkeyboardupfunc"
 subroutine f9y1glutkeyboardupfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutkeyboardupfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutspecialupfunc"
 subroutine f9y1glutspecialupfunc()
 use opengl_kinds
 implicit none
 end subroutine f9y1glutspecialupfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9y1glutjoystickfunc"
 subroutine f9y1glutjoystickfunc(pollinterval)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: pollinterval
 end subroutine f9y1glutjoystickfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutignorekeyrepeat"
 subroutine fglutignorekeyrepeat(ignore)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: ignore
 end subroutine fglutignorekeyrepeat
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutsetkeyrepeat"
 subroutine fglutsetkeyrepeat(repeatmode)
 use opengl_kinds
 implicit none
 integer(kind=glint) ,intent(in) :: repeatmode
 end subroutine fglutsetkeyrepeat
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutforcejoystickfunc"
 subroutine fglutforcejoystickfunc()
 use opengl_kinds
 implicit none
 end subroutine fglutforcejoystickfunc
 end interface
 
 interface
 !NAS$ ALIEN "F77 f9yglutgamemodestring"
 subroutine f9yglutgamemodestring(string,size_string)
 use opengl_kinds
 implicit none
 integer(kind=glint), dimension(*) ,intent(in) :: string
 integer(kind=glint) ,intent(in) :: size_string
 end subroutine f9yglutgamemodestring
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutentergamemode"
 function fglutentergamemode() result(resfglutentergamemode)
 use opengl_kinds
 implicit none
 integer(kind=glcint) :: resfglutentergamemode
 end function fglutentergamemode
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutleavegamemode"
 subroutine fglutleavegamemode()
 use opengl_kinds
 implicit none
 end subroutine fglutleavegamemode
 end interface
 
 interface
 !NAS$ ALIEN "F77 fglutgamemodeget"
 function fglutgamemodeget(mode) result(resfglutgamemodeget)
 use opengl_kinds
 implicit none
 integer(kind=glenum) ,intent(in) :: mode
 integer(kind=glcint) :: resfglutgamemodeget
 end function fglutgamemodeget
 end interface
 
 
 interface
 subroutine fglutbuttonboxfunc(buttonboxfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine buttonboxfunc(button,state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: button, state
    end subroutine buttonboxfunc
 end interface
 end subroutine fglutbuttonboxfunc
 end interface
 
 interface
 function fglutcreatemenu(selectfunc) result(resfglutcreatemenu)
 use opengl_kinds
 implicit none
 interface
     subroutine selectfunc(value)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: value
    end subroutine selectfunc
 end interface
 integer(kind=glcint) :: resfglutcreatemenu
 end function fglutcreatemenu
 end interface
 
 interface
 subroutine fglutdialsfunc(dialsfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine dialsfunc(dial,value)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: dial, value
    end subroutine dialsfunc
 end interface
 end subroutine fglutdialsfunc
 end interface
 
 interface
 subroutine fglutdisplayfunc(displayfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine displayfunc()
    use opengl_kinds
    implicit none
    end subroutine displayfunc
 end interface
 end subroutine fglutdisplayfunc
 end interface
 
 interface
 subroutine fglutentryfunc(entryfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine entryfunc(state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: state
    end subroutine entryfunc
 end interface
 end subroutine fglutentryfunc
 end interface
 
 interface
 subroutine fglutidlefunc(idlefunc)
 use opengl_kinds
 implicit none
 interface
     subroutine idlefunc()
    use opengl_kinds
    implicit none
    end subroutine idlefunc
 end interface
 end subroutine fglutidlefunc
 end interface
 
 interface
 subroutine fglutkeyboardfunc(keyboardfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine keyboardfunc(key,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glint) , intent(in out) :: key
    integer(kind=glcint) , intent(in out) :: x, y
    end subroutine keyboardfunc
 end interface
 end subroutine fglutkeyboardfunc
 end interface
 
 interface
 subroutine fglutmenustatefunc(menustatefunc)
 use opengl_kinds
 implicit none
 interface
     subroutine menustatefunc(state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: state
    end subroutine menustatefunc
 end interface
 end subroutine fglutmenustatefunc
 end interface
 
 interface
 subroutine fglutmenustatusfunc(menustatusfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine menustatusfunc(status,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: status, x, y
    end subroutine menustatusfunc
 end interface
 end subroutine fglutmenustatusfunc
 end interface
 
 interface
 subroutine fglutmotionfunc(motionfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine motionfunc(x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: x, y
    end subroutine motionfunc
 end interface
 end subroutine fglutmotionfunc
 end interface
 
 interface
 subroutine fglutmousefunc(mousefunc)
 use opengl_kinds
 implicit none
 interface
     subroutine mousefunc(button,state,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: button, state, x, y
    end subroutine mousefunc
 end interface
 end subroutine fglutmousefunc
 end interface
 
 interface
 subroutine fglutoverlaydisplayfunc(overlaydisplayfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine overlaydisplayfunc()
    use opengl_kinds
    implicit none
    end subroutine overlaydisplayfunc
 end interface
 end subroutine fglutoverlaydisplayfunc
 end interface
 
 interface
 subroutine fglutpassivemotionfunc(passivemotionfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine passivemotionfunc(x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: x, y
    end subroutine passivemotionfunc
 end interface
 end subroutine fglutpassivemotionfunc
 end interface
 
 interface
 subroutine fglutreshapefunc(reshapefunc)
 use opengl_kinds
 implicit none
 interface
     subroutine reshapefunc(width,height)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: width, height
    end subroutine reshapefunc
 end interface
 end subroutine fglutreshapefunc
 end interface
 
 interface
 subroutine fglutspaceballbuttonfunc(spaceballbuttonfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine spaceballbuttonfunc(button,state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: button, state
    end subroutine spaceballbuttonfunc
 end interface
 end subroutine fglutspaceballbuttonfunc
 end interface
 
 interface
 subroutine fglutspaceballmotionfunc(spaceballmotionfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine spaceballmotionfunc(x,y,z)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: x, y, z
    end subroutine spaceballmotionfunc
 end interface
 end subroutine fglutspaceballmotionfunc
 end interface
 
 interface
 subroutine fglutspaceballrotatefunc(spaceballrotatefunc)
 use opengl_kinds
 implicit none
 interface
     subroutine spaceballrotatefunc(x,y,z)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: x, y, z
    end subroutine spaceballrotatefunc
 end interface
 end subroutine fglutspaceballrotatefunc
 end interface
 
 interface
 subroutine fglutspecialfunc(specialfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine specialfunc(key,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: key, x, y
    end subroutine specialfunc
 end interface
 end subroutine fglutspecialfunc
 end interface
 
 interface
 subroutine fgluttabletbuttonfunc(tabletbuttonfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine tabletbuttonfunc(button,state,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: button, state, x, y
    end subroutine tabletbuttonfunc
 end interface
 end subroutine fgluttabletbuttonfunc
 end interface
 
 interface
 subroutine fgluttabletmotionfunc(tabletmotionfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine tabletmotionfunc(x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: x, y
    end subroutine tabletmotionfunc
 end interface
 end subroutine fgluttabletmotionfunc
 end interface
 
 interface
 subroutine fgluttimerfunc(millis,timerfunc,value)
 use opengl_kinds
 implicit none
 integer(kind=glcuint)  ,intent(in) :: millis
 interface
     subroutine timerfunc(value)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: value
    end subroutine timerfunc
 end interface
 integer(kind=glcint)  ,intent(in) :: value
 end subroutine fgluttimerfunc
 end interface
 
 interface
 subroutine fglutvisibilityfunc(visibilityfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine visibilityfunc(state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: state
    end subroutine visibilityfunc
 end interface
 end subroutine fglutvisibilityfunc
 end interface
 
 interface
 subroutine fglutwindowstatusfunc(windowstatusfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine windowstatusfunc(state)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: state
    end subroutine windowstatusfunc
 end interface
 end subroutine fglutwindowstatusfunc
 end interface
 
 
 interface
 subroutine fglutkeyboardupfunc(keyboardupfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine keyboardupfunc(key,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glint) , intent(in out) :: key
    integer(kind=glcint) , intent(in out) :: x, y
    end subroutine keyboardupfunc
 end interface
 end subroutine fglutkeyboardupfunc
 end interface
 
 interface
 subroutine fglutspecialupfunc(specialupfunc)
 use opengl_kinds
 implicit none
 interface
     subroutine specialupfunc(key,x,y)
    use opengl_kinds
    implicit none
    integer(kind=glcint) , intent(in out) :: key, x, y
    end subroutine specialupfunc
 end interface
 end subroutine fglutspecialupfunc
 end interface
 
 interface
 subroutine fglutjoystickfunc(joystickfunc,pollinterval)
 use opengl_kinds
 implicit none
 interface
     subroutine joystickfunc(buttonmask,x,y,z)
    use opengl_kinds
    implicit none
    integer(kind=glcuint) , intent(in out) :: buttonmask
    integer(kind=glcint) , intent(in out) :: x, y, z
    end subroutine joystickfunc
 end interface
 integer(kind=glint) ,intent(in) :: pollinterval
 end subroutine fglutjoystickfunc
 end interface
 
 
 
 end module opengl_glutinterfaces
